use ::libc;
extern "C" {
    pub type _IO_wide_data;
    pub type _IO_codecvt;
    pub type _IO_marker;
    #[no_mangle]
    static mut stdout: *mut FILE;
    #[no_mangle]
    fn fwrite(_: *const libc::c_void, _: libc::c_ulong, _: libc::c_ulong,
              _: *mut FILE) -> libc::c_ulong;
    #[no_mangle]
    fn malloc(_: libc::c_ulong) -> *mut libc::c_void;
    #[no_mangle]
    fn free(__ptr: *mut libc::c_void);
    #[no_mangle]
    fn memset(_: *mut libc::c_void, _: libc::c_int, _: libc::c_ulong)
     -> *mut libc::c_void;
    #[no_mangle]
    fn strcmp(_: *const libc::c_char, _: *const libc::c_char) -> libc::c_int;
    #[no_mangle]
    fn _apply_cross(outputbuf_0: *mut buffer, out_frames: frames_t,
                    cross_gain_in: s32_t, cross_gain_out: s32_t,
                    cross_ptr: *mut *mut s32_t);
    #[no_mangle]
    fn _scale_and_pack_frames(outputptr: *mut libc::c_void,
                              inputptr: *mut s32_t, cnt: frames_t,
                              gainL: s32_t, gainR: s32_t,
                              format: output_format);
    #[no_mangle]
    fn _output_frames(avail: frames_t) -> frames_t;
    #[no_mangle]
    fn output_close_common();
    #[no_mangle]
    fn output_init_common(level: log_level, device: *const libc::c_char,
                          output_buf_size: libc::c_uint,
                          rates: *mut libc::c_uint, idle: libc::c_uint);
    #[no_mangle]
    fn pthread_create(__newthread: *mut pthread_t,
                      __attr: *const pthread_attr_t,
                      __start_routine:
                          Option<unsafe extern "C" fn(_: *mut libc::c_void)
                                     -> *mut libc::c_void>,
                      __arg: *mut libc::c_void) -> libc::c_int;
    #[no_mangle]
    fn pthread_attr_init(__attr: *mut pthread_attr_t) -> libc::c_int;
    #[no_mangle]
    fn pthread_attr_destroy(__attr: *mut pthread_attr_t) -> libc::c_int;
    #[no_mangle]
    fn pthread_attr_setstacksize(__attr: *mut pthread_attr_t,
                                 __stacksize: size_t) -> libc::c_int;
    #[no_mangle]
    fn pthread_mutex_lock(__mutex: *mut pthread_mutex_t) -> libc::c_int;
    #[no_mangle]
    fn pthread_mutex_unlock(__mutex: *mut pthread_mutex_t) -> libc::c_int;
    #[no_mangle]
    fn logtime() -> *const libc::c_char;
    #[no_mangle]
    fn logprint(fmt: *const libc::c_char, _: ...);
    #[no_mangle]
    fn gettime_ms() -> u32_t;
    #[no_mangle]
    static mut output: outputstate;
    #[no_mangle]
    static mut outputbuf: *mut buffer;
    #[no_mangle]
    static mut silencebuf: *mut u8_t;
}
pub type size_t = libc::c_ulong;
pub type __uint8_t = libc::c_uchar;
pub type __int32_t = libc::c_int;
pub type __uint32_t = libc::c_uint;
pub type __off_t = libc::c_long;
pub type __off64_t = libc::c_long;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct _IO_FILE {
    pub _flags: libc::c_int,
    pub _IO_read_ptr: *mut libc::c_char,
    pub _IO_read_end: *mut libc::c_char,
    pub _IO_read_base: *mut libc::c_char,
    pub _IO_write_base: *mut libc::c_char,
    pub _IO_write_ptr: *mut libc::c_char,
    pub _IO_write_end: *mut libc::c_char,
    pub _IO_buf_base: *mut libc::c_char,
    pub _IO_buf_end: *mut libc::c_char,
    pub _IO_save_base: *mut libc::c_char,
    pub _IO_backup_base: *mut libc::c_char,
    pub _IO_save_end: *mut libc::c_char,
    pub _markers: *mut _IO_marker,
    pub _chain: *mut _IO_FILE,
    pub _fileno: libc::c_int,
    pub _flags2: libc::c_int,
    pub _old_offset: __off_t,
    pub _cur_column: libc::c_ushort,
    pub _vtable_offset: libc::c_schar,
    pub _shortbuf: [libc::c_char; 1],
    pub _lock: *mut libc::c_void,
    pub _offset: __off64_t,
    pub _codecvt: *mut _IO_codecvt,
    pub _wide_data: *mut _IO_wide_data,
    pub _freeres_list: *mut _IO_FILE,
    pub _freeres_buf: *mut libc::c_void,
    pub __pad5: size_t,
    pub _mode: libc::c_int,
    pub _unused2: [libc::c_char; 20],
}
pub type _IO_lock_t = ();
pub type FILE = _IO_FILE;
pub type int32_t = __int32_t;
pub type u_int8_t = __uint8_t;
pub type u_int32_t = __uint32_t;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct __pthread_internal_list {
    pub __prev: *mut __pthread_internal_list,
    pub __next: *mut __pthread_internal_list,
}
pub type __pthread_list_t = __pthread_internal_list;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct __pthread_mutex_s {
    pub __lock: libc::c_int,
    pub __count: libc::c_uint,
    pub __owner: libc::c_int,
    pub __nusers: libc::c_uint,
    pub __kind: libc::c_int,
    pub __spins: libc::c_short,
    pub __elision: libc::c_short,
    pub __list: __pthread_list_t,
}
pub type pthread_t = libc::c_ulong;
#[derive(Copy, Clone)]
#[repr(C)]
pub union pthread_attr_t {
    pub __size: [libc::c_char; 56],
    pub __align: libc::c_long,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub union pthread_mutex_t {
    pub __data: __pthread_mutex_s,
    pub __size: [libc::c_char; 40],
    pub __align: libc::c_long,
}
pub type u8_t = u_int8_t;
pub type u32_t = u_int32_t;
pub type s32_t = int32_t;
pub type frames_t = u32_t;
pub type log_level = libc::c_uint;
pub const lSDEBUG: log_level = 4;
pub const lDEBUG: log_level = 3;
pub const lINFO: log_level = 2;
pub const lWARN: log_level = 1;
pub const lERROR: log_level = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct buffer {
    pub buf: *mut u8_t,
    pub readp: *mut u8_t,
    pub writep: *mut u8_t,
    pub wrap: *mut u8_t,
    pub size: size_t,
    pub base_size: size_t,
    pub mutex: pthread_mutex_t,
}
pub type output_state = libc::c_int;
pub const OUTPUT_START_AT: output_state = 5;
pub const OUTPUT_SKIP_FRAMES: output_state = 4;
pub const OUTPUT_PAUSE_FRAMES: output_state = 3;
pub const OUTPUT_RUNNING: output_state = 2;
pub const OUTPUT_BUFFER: output_state = 1;
pub const OUTPUT_STOPPED: output_state = 0;
pub const OUTPUT_OFF: output_state = -1;
pub type output_format = libc::c_uint;
pub const S16_LE: output_format = 3;
pub const S24_3LE: output_format = 2;
pub const S24_LE: output_format = 1;
pub const S32_LE: output_format = 0;
pub type fade_state = libc::c_uint;
pub const FADE_ACTIVE: fade_state = 2;
pub const FADE_DUE: fade_state = 1;
pub const FADE_INACTIVE: fade_state = 0;
pub type fade_dir = libc::c_uint;
pub const FADE_CROSS: fade_dir = 3;
pub const FADE_DOWN: fade_dir = 2;
pub const FADE_UP: fade_dir = 1;
pub type fade_mode = libc::c_uint;
pub const FADE_INOUT: fade_mode = 4;
pub const FADE_OUT: fade_mode = 3;
pub const FADE_IN: fade_mode = 2;
pub const FADE_CROSSFADE: fade_mode = 1;
pub const FADE_NONE: fade_mode = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct outputstate {
    pub state: output_state,
    pub format: output_format,
    pub device: *const libc::c_char,
    pub buffer: libc::c_uint,
    pub period: libc::c_uint,
    pub track_started: bool,
    pub write_cb: Option<unsafe extern "C" fn(_: frames_t, _: bool, _: s32_t,
                                              _: s32_t, _: s32_t, _: s32_t,
                                              _: *mut *mut s32_t)
                             -> libc::c_int>,
    pub start_frames: libc::c_uint,
    pub frames_played: libc::c_uint,
    pub frames_played_dmp: libc::c_uint,
    pub current_sample_rate: libc::c_uint,
    pub supported_rates: [libc::c_uint; 18],
    pub default_sample_rate: libc::c_uint,
    pub error_opening: bool,
    pub device_frames: libc::c_uint,
    pub updated: u32_t,
    pub track_start_time: u32_t,
    pub current_replay_gain: u32_t,
    pub c2rust_unnamed: C2RustUnnamed,
    pub next_sample_rate: libc::c_uint,
    pub track_start: *mut u8_t,
    pub gainL: u32_t,
    pub gainR: u32_t,
    pub invert: bool,
    pub next_replay_gain: u32_t,
    pub threshold: libc::c_uint,
    pub fade: fade_state,
    pub fade_start: *mut u8_t,
    pub fade_end: *mut u8_t,
    pub fade_dir: fade_dir,
    pub fade_mode: fade_mode,
    pub fade_secs: libc::c_uint,
    pub rate_delay: libc::c_uint,
    pub delay_active: bool,
    pub stop_time: u32_t,
    pub idle_to: u32_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub union C2RustUnnamed {
    pub pause_frames: u32_t,
    pub skip_frames: u32_t,
    pub start_at: u32_t,
}
static mut loglevel: log_level = lERROR;
static mut running: bool = 1 as libc::c_int != 0;
// buffer to hold output data so we can block on writing outside of output lock, allocated on init
static mut buf: *mut u8_t = 0 as *const u8_t as *mut u8_t;
static mut buffill: libc::c_uint = 0;
static mut bytes_per_frame: libc::c_int = 0;
unsafe extern "C" fn _stdout_write_frames(mut out_frames: frames_t,
                                          mut silence: bool, mut gainL: s32_t,
                                          mut gainR: s32_t,
                                          mut cross_gain_in: s32_t,
                                          mut cross_gain_out: s32_t,
                                          mut cross_ptr: *mut *mut s32_t)
 -> libc::c_int {
    let mut obuf: *mut u8_t = 0 as *mut u8_t;
    if !silence {
        if output.fade as libc::c_uint ==
               FADE_ACTIVE as libc::c_int as libc::c_uint &&
               output.fade_dir as libc::c_uint ==
                   FADE_CROSS as libc::c_int as libc::c_uint &&
               !(*cross_ptr).is_null() {
            _apply_cross(outputbuf, out_frames, cross_gain_in, cross_gain_out,
                         cross_ptr);
        }
        obuf = (*outputbuf).readp
    } else { obuf = silencebuf }
    _scale_and_pack_frames(buf.offset(buffill.wrapping_mul(bytes_per_frame as
                                                               libc::c_uint)
                                          as isize) as *mut libc::c_void,
                           obuf as *mut libc::c_void as *mut s32_t,
                           out_frames, gainL, gainR, output.format);
    buffill = buffill.wrapping_add(out_frames);
    return out_frames as libc::c_int;
}
unsafe extern "C" fn output_thread() -> *mut libc::c_void {
    pthread_mutex_lock(&mut (*outputbuf).mutex);
    match output.format as libc::c_uint {
        0 => { bytes_per_frame = 4 as libc::c_int * 2 as libc::c_int }
        2 => { bytes_per_frame = 3 as libc::c_int * 2 as libc::c_int }
        3 => { bytes_per_frame = 2 as libc::c_int * 2 as libc::c_int }
        _ => { bytes_per_frame = 4 as libc::c_int * 2 as libc::c_int }
    }
    pthread_mutex_unlock(&mut (*outputbuf).mutex);
    while running {
        pthread_mutex_lock(&mut (*outputbuf).mutex);
        output.device_frames = 0 as libc::c_int as libc::c_uint;
        output.updated = gettime_ms();
        output.frames_played_dmp = output.frames_played;
        _output_frames(2048 as libc::c_int as frames_t);
        pthread_mutex_unlock(&mut (*outputbuf).mutex);
        if buffill != 0 {
            fwrite(buf as *const libc::c_void,
                   bytes_per_frame as libc::c_ulong, buffill as libc::c_ulong,
                   stdout);
            buffill = 0 as libc::c_int as libc::c_uint
        }
    }
    return 0 as *mut libc::c_void;
}
static mut thread: pthread_t = 0;
#[no_mangle]
pub unsafe extern "C" fn output_init_stdout(mut level: log_level,
                                            mut output_buf_size: libc::c_uint,
                                            mut params: *mut libc::c_char,
                                            mut rates: *mut libc::c_uint,
                                            mut rate_delay: libc::c_uint) {
    loglevel = level;
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d init output stdout\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 19],
                                           &[libc::c_char; 19]>(b"output_init_stdout\x00")).as_ptr(),
                 130 as libc::c_int);
    }
    buf =
        malloc((2048 as libc::c_int * 8 as libc::c_int) as libc::c_ulong) as
            *mut u8_t;
    if buf.is_null() {
        logprint(b"%s %s:%d unable to malloc buf\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 19],
                                           &[libc::c_char; 19]>(b"output_init_stdout\x00")).as_ptr(),
                 134 as libc::c_int);
        return
    }
    buffill = 0 as libc::c_int as libc::c_uint;
    memset(&mut output as *mut outputstate as *mut libc::c_void,
           0 as libc::c_int,
           ::std::mem::size_of::<outputstate>() as libc::c_ulong);
    output.format = S32_LE;
    output.start_frames =
        (2048 as libc::c_int * 2 as libc::c_int) as libc::c_uint;
    output.write_cb =
        Some(_stdout_write_frames as
                 unsafe extern "C" fn(_: frames_t, _: bool, _: s32_t,
                                      _: s32_t, _: s32_t, _: s32_t,
                                      _: *mut *mut s32_t) -> libc::c_int);
    output.rate_delay = rate_delay;
    if !params.is_null() {
        if strcmp(params, b"32\x00" as *const u8 as *const libc::c_char) == 0
           {
            output.format = S32_LE
        }
        if strcmp(params, b"24\x00" as *const u8 as *const libc::c_char) == 0
           {
            output.format = S24_3LE
        }
        if strcmp(params, b"16\x00" as *const u8 as *const libc::c_char) == 0
           {
            output.format = S16_LE
        }
    }
    // ensure output rate is specified to avoid test open
    if *rates.offset(0 as libc::c_int as isize) == 0 {
        *rates.offset(0 as libc::c_int as isize) =
            44100 as libc::c_int as libc::c_uint
    }
    output_init_common(level, b"-\x00" as *const u8 as *const libc::c_char,
                       output_buf_size, rates,
                       0 as libc::c_int as libc::c_uint);
    let mut attr: pthread_attr_t = pthread_attr_t{__size: [0; 56],};
    pthread_attr_init(&mut attr);
    pthread_attr_setstacksize(&mut attr,
                              (16384 as libc::c_int +
                                   64 as libc::c_int * 1024 as libc::c_int) as
                                  size_t);
    pthread_create(&mut thread, &mut attr,
                   ::std::mem::transmute::<Option<unsafe extern "C" fn()
                                                      -> *mut libc::c_void>,
                                           Option<unsafe extern "C" fn(_:
                                                                           *mut libc::c_void)
                                                      ->
                                                          *mut libc::c_void>>(Some(::std::mem::transmute::<unsafe extern "C" fn()
                                                                                                               ->
                                                                                                                   *mut libc::c_void,
                                                                                                           unsafe extern "C" fn()
                                                                                                               ->
                                                                                                                   *mut libc::c_void>(output_thread))),
                   0 as *mut libc::c_void);
    pthread_attr_destroy(&mut attr);
}
/* 
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *  
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additions (c) Paul Hermann, 2015-2017 under the same license terms
 *   -Control of Raspberry pi GPIO for amplifier power
 *   -Launch script on power status change from LMS
 */
// make may define: PORTAUDIO, SELFPIPE, RESAMPLE, RESAMPLE_MP, VISEXPORT, GPIO, IR, DSD, LINKALL to influence build
// build detection
// dynamically loaded libraries at run time
// !LINKALL
// config options
// do not reduce as icy-meta max is 4080
/* SUN */
/* SUN */
// printf/scanf formats for u64_t
// logging
// utils.c (non logging)
// buffer.c
// _* called with mutex locked
// slimproto.c
// stream.c
// decode.c
// output.c output_alsa.c output_pa.c output_pack.c
// frames played at the point delay is measured
// ordered largest first so [0] is max_rate
// set in decode thread
// set in decode thread
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// _* called with mutex locked
// output_alsa.c
// output_pa.c
// output_pulse.c
// output_stdout.c
#[no_mangle]
pub unsafe extern "C" fn output_close_stdout() {
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d close output\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 20],
                                           &[libc::c_char; 20]>(b"output_close_stdout\x00")).as_ptr(),
                 174 as libc::c_int);
    }
    pthread_mutex_lock(&mut (*outputbuf).mutex);
    running = 0 as libc::c_int != 0;
    pthread_mutex_unlock(&mut (*outputbuf).mutex);
    free(buf as *mut libc::c_void);
    output_close_common();
}
