use ::libc;
extern "C" {
    pub type _IO_wide_data;
    pub type _IO_codecvt;
    pub type _IO_marker;
    #[no_mangle]
    fn close(__fd: libc::c_int) -> libc::c_int;
    #[no_mangle]
    fn sleep(__seconds: libc::c_uint) -> libc::c_uint;
    #[no_mangle]
    fn usleep(__useconds: __useconds_t) -> libc::c_int;
    #[no_mangle]
    fn fopen(_: *const libc::c_char, _: *const libc::c_char) -> *mut FILE;
    #[no_mangle]
    fn snprintf(_: *mut libc::c_char, _: libc::c_ulong,
                _: *const libc::c_char, _: ...) -> libc::c_int;
    #[no_mangle]
    fn fgets(__s: *mut libc::c_char, __n: libc::c_int, __stream: *mut FILE)
     -> *mut libc::c_char;
    #[no_mangle]
    fn fputs(__s: *const libc::c_char, __stream: *mut FILE) -> libc::c_int;
    #[no_mangle]
    fn malloc(_: libc::c_ulong) -> *mut libc::c_void;
    #[no_mangle]
    fn free(__ptr: *mut libc::c_void);
    #[no_mangle]
    fn memcpy(_: *mut libc::c_void, _: *const libc::c_void, _: libc::c_ulong)
     -> *mut libc::c_void;
    #[no_mangle]
    fn memset(_: *mut libc::c_void, _: libc::c_int, _: libc::c_ulong)
     -> *mut libc::c_void;
    #[no_mangle]
    fn strncpy(_: *mut libc::c_char, _: *const libc::c_char, _: libc::c_ulong)
     -> *mut libc::c_char;
    #[no_mangle]
    fn strcat(_: *mut libc::c_char, _: *const libc::c_char)
     -> *mut libc::c_char;
    #[no_mangle]
    fn strncat(_: *mut libc::c_char, _: *const libc::c_char, _: libc::c_ulong)
     -> *mut libc::c_char;
    #[no_mangle]
    fn strncmp(_: *const libc::c_char, _: *const libc::c_char,
               _: libc::c_ulong) -> libc::c_int;
    #[no_mangle]
    fn __errno_location() -> *mut libc::c_int;
    #[no_mangle]
    fn fclose(__stream: *mut FILE) -> libc::c_int;
    #[no_mangle]
    fn socket(__domain: libc::c_int, __type: libc::c_int,
              __protocol: libc::c_int) -> libc::c_int;
    #[no_mangle]
    fn getsockname(__fd: libc::c_int, __addr: *mut sockaddr,
                   __len: *mut socklen_t) -> libc::c_int;
    #[no_mangle]
    fn send(__fd: libc::c_int, __buf: *const libc::c_void, __n: size_t,
            __flags: libc::c_int) -> ssize_t;
    #[no_mangle]
    fn recv(__fd: libc::c_int, __buf: *mut libc::c_void, __n: size_t,
            __flags: libc::c_int) -> ssize_t;
    #[no_mangle]
    fn sendto(__fd: libc::c_int, __buf: *const libc::c_void, __n: size_t,
              __flags: libc::c_int, __addr: *const sockaddr,
              __addr_len: socklen_t) -> ssize_t;
    #[no_mangle]
    fn recvfrom(__fd: libc::c_int, __buf: *mut libc::c_void, __n: size_t,
                __flags: libc::c_int, __addr: *mut sockaddr,
                __addr_len: *mut socklen_t) -> ssize_t;
    #[no_mangle]
    fn setsockopt(__fd: libc::c_int, __level: libc::c_int,
                  __optname: libc::c_int, __optval: *const libc::c_void,
                  __optlen: socklen_t) -> libc::c_int;
    #[no_mangle]
    fn ntohs(__netshort: uint16_t) -> uint16_t;
    #[no_mangle]
    fn htonl(__hostlong: uint32_t) -> uint32_t;
    #[no_mangle]
    fn htons(__hostshort: uint16_t) -> uint16_t;
    #[no_mangle]
    fn inet_ntoa(__in: in_addr) -> *mut libc::c_char;
    #[no_mangle]
    fn poll(__fds: *mut pollfd, __nfds: nfds_t, __timeout: libc::c_int)
     -> libc::c_int;
    #[no_mangle]
    fn pthread_mutex_lock(__mutex: *mut pthread_mutex_t) -> libc::c_int;
    #[no_mangle]
    fn pthread_mutex_unlock(__mutex: *mut pthread_mutex_t) -> libc::c_int;
    #[no_mangle]
    fn eventfd(__count: libc::c_uint, __flags: libc::c_int) -> libc::c_int;
    #[no_mangle]
    fn eventfd_write(__fd: libc::c_int, __value: eventfd_t) -> libc::c_int;
    #[no_mangle]
    fn logtime() -> *const libc::c_char;
    #[no_mangle]
    fn logprint(fmt: *const libc::c_char, _: ...);
    #[no_mangle]
    fn gettime_ms() -> u32_t;
    #[no_mangle]
    fn set_nonblock(s: sockfd);
    #[no_mangle]
    fn connect_timeout(sock_0: sockfd, addr: *const sockaddr,
                       addrlen: socklen_t, timeout: libc::c_int)
     -> libc::c_int;
    #[no_mangle]
    fn server_addr(server: *mut libc::c_char, ip_ptr: *mut in_addr_t,
                   port_ptr: *mut libc::c_uint);
    #[no_mangle]
    fn set_readwake_handles(handles: *mut pollfd, s: sockfd, e: libc::c_int);
    #[no_mangle]
    fn wait_readwake(handles: *mut pollfd, timeout: libc::c_int)
     -> event_type;
    #[no_mangle]
    fn packN(dest: *mut u32_t, val: u32_t);
    #[no_mangle]
    fn packn(dest: *mut u16_t, val: u16_t);
    #[no_mangle]
    fn unpackN(src: *mut u32_t) -> u32_t;
    #[no_mangle]
    fn _buf_used(buf: *mut buffer) -> libc::c_uint;
    #[no_mangle]
    fn buf_flush(buf: *mut buffer);
    #[no_mangle]
    fn decode_flush();
    #[no_mangle]
    fn output_flush();
    #[no_mangle]
    fn stream_file(header: *const libc::c_char, header_len: size_t,
                   threshold: libc::c_uint);
    #[no_mangle]
    fn stream_sock(ip: u32_t, port: u16_t, header: *const libc::c_char,
                   header_len: size_t, threshold: libc::c_uint,
                   cont_wait: bool);
    #[no_mangle]
    fn codec_open(format: u8_t, sample_size: u8_t, sample_rate: u8_t,
                  channels: u8_t, endianness: u8_t);
    #[no_mangle]
    fn set_volume(left: libc::c_uint, right: libc::c_uint);
    #[no_mangle]
    fn stream_disconnect() -> bool;
    #[no_mangle]
    fn strlen(_: *const libc::c_char) -> libc::c_ulong;
    #[no_mangle]
    fn strerror(_: libc::c_int) -> *mut libc::c_char;
    #[no_mangle]
    static mut streambuf: *mut buffer;
    #[no_mangle]
    static mut outputbuf: *mut buffer;
    #[no_mangle]
    static mut stream: streamstate;
    #[no_mangle]
    static mut output: outputstate;
    #[no_mangle]
    static mut decode: decodestate;
    #[no_mangle]
    static mut codecs: [*mut codec; 0];
}
pub type size_t = libc::c_ulong;
pub type __uint8_t = libc::c_uchar;
pub type __uint16_t = libc::c_ushort;
pub type __int32_t = libc::c_int;
pub type __uint32_t = libc::c_uint;
pub type __uint64_t = libc::c_ulong;
pub type __off_t = libc::c_long;
pub type __off64_t = libc::c_long;
pub type __useconds_t = libc::c_uint;
pub type __ssize_t = libc::c_long;
pub type __socklen_t = libc::c_uint;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct _IO_FILE {
    pub _flags: libc::c_int,
    pub _IO_read_ptr: *mut libc::c_char,
    pub _IO_read_end: *mut libc::c_char,
    pub _IO_read_base: *mut libc::c_char,
    pub _IO_write_base: *mut libc::c_char,
    pub _IO_write_ptr: *mut libc::c_char,
    pub _IO_write_end: *mut libc::c_char,
    pub _IO_buf_base: *mut libc::c_char,
    pub _IO_buf_end: *mut libc::c_char,
    pub _IO_save_base: *mut libc::c_char,
    pub _IO_backup_base: *mut libc::c_char,
    pub _IO_save_end: *mut libc::c_char,
    pub _markers: *mut _IO_marker,
    pub _chain: *mut _IO_FILE,
    pub _fileno: libc::c_int,
    pub _flags2: libc::c_int,
    pub _old_offset: __off_t,
    pub _cur_column: libc::c_ushort,
    pub _vtable_offset: libc::c_schar,
    pub _shortbuf: [libc::c_char; 1],
    pub _lock: *mut libc::c_void,
    pub _offset: __off64_t,
    pub _codecvt: *mut _IO_codecvt,
    pub _wide_data: *mut _IO_wide_data,
    pub _freeres_list: *mut _IO_FILE,
    pub _freeres_buf: *mut libc::c_void,
    pub __pad5: size_t,
    pub _mode: libc::c_int,
    pub _unused2: [libc::c_char; 20],
}
pub type _IO_lock_t = ();
pub type FILE = _IO_FILE;
pub type ssize_t = __ssize_t;
pub type int32_t = __int32_t;
pub type u_int8_t = __uint8_t;
pub type u_int16_t = __uint16_t;
pub type u_int32_t = __uint32_t;
pub type u_int64_t = __uint64_t;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct __pthread_internal_list {
    pub __prev: *mut __pthread_internal_list,
    pub __next: *mut __pthread_internal_list,
}
pub type __pthread_list_t = __pthread_internal_list;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct __pthread_mutex_s {
    pub __lock: libc::c_int,
    pub __count: libc::c_uint,
    pub __owner: libc::c_int,
    pub __nusers: libc::c_uint,
    pub __kind: libc::c_int,
    pub __spins: libc::c_short,
    pub __elision: libc::c_short,
    pub __list: __pthread_list_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub union pthread_mutex_t {
    pub __data: __pthread_mutex_s,
    pub __size: [libc::c_char; 40],
    pub __align: libc::c_long,
}
pub type socklen_t = __socklen_t;
pub type uint16_t = __uint16_t;
pub type uint32_t = __uint32_t;
pub type uint64_t = __uint64_t;
pub type __socket_type = libc::c_uint;
pub const SOCK_NONBLOCK: __socket_type = 2048;
pub const SOCK_CLOEXEC: __socket_type = 524288;
pub const SOCK_PACKET: __socket_type = 10;
pub const SOCK_DCCP: __socket_type = 6;
pub const SOCK_SEQPACKET: __socket_type = 5;
pub const SOCK_RDM: __socket_type = 4;
pub const SOCK_RAW: __socket_type = 3;
pub const SOCK_DGRAM: __socket_type = 2;
pub const SOCK_STREAM: __socket_type = 1;
pub type sa_family_t = libc::c_ushort;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct sockaddr {
    pub sa_family: sa_family_t,
    pub sa_data: [libc::c_char; 14],
}
pub type C2RustUnnamed = libc::c_uint;
pub const MSG_CMSG_CLOEXEC: C2RustUnnamed = 1073741824;
pub const MSG_FASTOPEN: C2RustUnnamed = 536870912;
pub const MSG_ZEROCOPY: C2RustUnnamed = 67108864;
pub const MSG_BATCH: C2RustUnnamed = 262144;
pub const MSG_WAITFORONE: C2RustUnnamed = 65536;
pub const MSG_MORE: C2RustUnnamed = 32768;
pub const MSG_NOSIGNAL: C2RustUnnamed = 16384;
pub const MSG_ERRQUEUE: C2RustUnnamed = 8192;
pub const MSG_RST: C2RustUnnamed = 4096;
pub const MSG_CONFIRM: C2RustUnnamed = 2048;
pub const MSG_SYN: C2RustUnnamed = 1024;
pub const MSG_FIN: C2RustUnnamed = 512;
pub const MSG_WAITALL: C2RustUnnamed = 256;
pub const MSG_EOR: C2RustUnnamed = 128;
pub const MSG_DONTWAIT: C2RustUnnamed = 64;
pub const MSG_TRUNC: C2RustUnnamed = 32;
pub const MSG_PROXY: C2RustUnnamed = 16;
pub const MSG_CTRUNC: C2RustUnnamed = 8;
pub const MSG_DONTROUTE: C2RustUnnamed = 4;
pub const MSG_PEEK: C2RustUnnamed = 2;
pub const MSG_OOB: C2RustUnnamed = 1;
pub type in_addr_t = uint32_t;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct in_addr {
    pub s_addr: in_addr_t,
}
pub type in_port_t = uint16_t;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct sockaddr_in {
    pub sin_family: sa_family_t,
    pub sin_port: in_port_t,
    pub sin_addr: in_addr,
    pub sin_zero: [libc::c_uchar; 8],
}
pub type nfds_t = libc::c_ulong;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct pollfd {
    pub fd: libc::c_int,
    pub events: libc::c_short,
    pub revents: libc::c_short,
}
pub type u8_t = u_int8_t;
pub type u16_t = u_int16_t;
pub type u32_t = u_int32_t;
pub type u64_t = u_int64_t;
pub type s32_t = int32_t;
pub type frames_t = u32_t;
pub type sockfd = libc::c_int;
pub type eventfd_t = uint64_t;
pub type log_level = libc::c_uint;
pub const lSDEBUG: log_level = 4;
pub const lDEBUG: log_level = 3;
pub const lINFO: log_level = 2;
pub const lWARN: log_level = 1;
pub const lERROR: log_level = 0;
pub type event_type = libc::c_uint;
pub const EVENT_WAKE: event_type = 2;
pub const EVENT_READ: event_type = 1;
pub const EVENT_TIMEOUT: event_type = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct buffer {
    pub buf: *mut u8_t,
    pub readp: *mut u8_t,
    pub writep: *mut u8_t,
    pub wrap: *mut u8_t,
    pub size: size_t,
    pub base_size: size_t,
    pub mutex: pthread_mutex_t,
}
// char header[] - added in sendRESP
// S:N:Slimproto _http_metadata_handler
#[derive(Copy, Clone)]
#[repr(C, packed)]
pub struct META_header {
    pub opcode: [libc::c_char; 4],
    pub length: u32_t,
}
// S:N:Slimproto _http_response_handler
#[derive(Copy, Clone)]
#[repr(C, packed)]
pub struct RESP_header {
    pub opcode: [libc::c_char; 4],
    pub length: u32_t,
}
//	u8_t capabilities[];
// S:N:Slimproto _stat_handler
#[derive(Copy, Clone)]
#[repr(C, packed)]
pub struct STAT_packet {
    pub opcode: [libc::c_char; 4],
    pub length: u32_t,
    pub event: u32_t,
    pub num_crlf: u8_t,
    pub mas_initialized: u8_t,
    pub mas_mode: u8_t,
    pub stream_buffer_size: u32_t,
    pub stream_buffer_fullness: u32_t,
    pub bytes_received_H: u32_t,
    pub bytes_received_L: u32_t,
    pub signal_strength: u16_t,
    pub jiffies: u32_t,
    pub output_buffer_size: u32_t,
    pub output_buffer_fullness: u32_t,
    pub elapsed_seconds: u32_t,
    pub voltage: u16_t,
    pub elapsed_milliseconds: u32_t,
    pub server_timestamp: u32_t,
    pub error_code: u16_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct C2RustUnnamed_0 {
    pub updated: u32_t,
    pub stream_start: u32_t,
    pub stream_full: u32_t,
    pub stream_size: u32_t,
    pub stream_bytes: u64_t,
    pub output_full: u32_t,
    pub output_size: u32_t,
    pub frames_played: u32_t,
    pub device_frames: u32_t,
    pub current_sample_rate: u32_t,
    pub last: u32_t,
    pub stream_state: stream_state,
}
pub type stream_state = libc::c_uint;
pub const RECV_HEADERS: stream_state = 7;
pub const SEND_HEADERS: stream_state = 6;
pub const STREAMING_HTTP: stream_state = 5;
pub const STREAMING_FILE: stream_state = 4;
pub const STREAMING_BUFFERING: stream_state = 3;
pub const STREAMING_WAIT: stream_state = 2;
pub const DISCONNECT: stream_state = 1;
pub const STOPPED: stream_state = 0;
pub type disconnect_code = libc::c_uint;
pub const TIMEOUT: disconnect_code = 4;
pub const UNREACHABLE: disconnect_code = 3;
pub const REMOTE_DISCONNECT: disconnect_code = 2;
pub const LOCAL_DISCONNECT: disconnect_code = 1;
pub const DISCONNECT_OK: disconnect_code = 0;
// S:N:Slimproto _disco_handler
#[derive(Copy, Clone)]
#[repr(C, packed)]
pub struct DSCO_packet {
    pub opcode: [libc::c_char; 4],
    pub length: u32_t,
    pub reason: u8_t,
}
pub const OUTPUT_RUNNING: output_state = 2;
pub type output_state = libc::c_int;
pub const OUTPUT_START_AT: output_state = 5;
pub const OUTPUT_SKIP_FRAMES: output_state = 4;
pub const OUTPUT_PAUSE_FRAMES: output_state = 3;
pub const OUTPUT_BUFFER: output_state = 1;
pub const OUTPUT_STOPPED: output_state = 0;
pub const OUTPUT_OFF: output_state = -1;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct outputstate {
    pub state: output_state,
    pub format: output_format,
    pub device: *const libc::c_char,
    pub buffer: libc::c_uint,
    pub period: libc::c_uint,
    pub track_started: bool,
    pub write_cb: Option<unsafe extern "C" fn(_: frames_t, _: bool, _: s32_t,
                                              _: s32_t, _: s32_t, _: s32_t,
                                              _: *mut *mut s32_t)
                             -> libc::c_int>,
    pub start_frames: libc::c_uint,
    pub frames_played: libc::c_uint,
    pub frames_played_dmp: libc::c_uint,
    pub current_sample_rate: libc::c_uint,
    pub supported_rates: [libc::c_uint; 18],
    pub default_sample_rate: libc::c_uint,
    pub error_opening: bool,
    pub device_frames: libc::c_uint,
    pub updated: u32_t,
    pub track_start_time: u32_t,
    pub current_replay_gain: u32_t,
    pub c2rust_unnamed: C2RustUnnamed_1,
    pub next_sample_rate: libc::c_uint,
    pub track_start: *mut u8_t,
    pub gainL: u32_t,
    pub gainR: u32_t,
    pub invert: bool,
    pub next_replay_gain: u32_t,
    pub threshold: libc::c_uint,
    pub fade: fade_state,
    pub fade_start: *mut u8_t,
    pub fade_end: *mut u8_t,
    pub fade_dir: fade_dir,
    pub fade_mode: fade_mode,
    pub fade_secs: libc::c_uint,
    pub rate_delay: libc::c_uint,
    pub delay_active: bool,
    pub stop_time: u32_t,
    pub idle_to: u32_t,
}
pub type fade_mode = libc::c_uint;
pub const FADE_INOUT: fade_mode = 4;
pub const FADE_OUT: fade_mode = 3;
pub const FADE_IN: fade_mode = 2;
pub const FADE_CROSSFADE: fade_mode = 1;
pub const FADE_NONE: fade_mode = 0;
pub type fade_dir = libc::c_uint;
pub const FADE_CROSS: fade_dir = 3;
pub const FADE_DOWN: fade_dir = 2;
pub const FADE_UP: fade_dir = 1;
pub type fade_state = libc::c_uint;
pub const FADE_ACTIVE: fade_state = 2;
pub const FADE_DUE: fade_state = 1;
pub const FADE_INACTIVE: fade_state = 0;
#[derive(Copy, Clone)]
#[repr(C)]
pub union C2RustUnnamed_1 {
    pub pause_frames: u32_t,
    pub skip_frames: u32_t,
    pub start_at: u32_t,
}
pub type output_format = libc::c_uint;
pub const S16_LE: output_format = 3;
pub const S24_3LE: output_format = 2;
pub const S24_LE: output_format = 1;
pub const S32_LE: output_format = 0;
pub const DECODE_STOPPED: decode_state = 0;
pub type decode_state = libc::c_uint;
pub const DECODE_ERROR: decode_state = 4;
pub const DECODE_COMPLETE: decode_state = 3;
pub const DECODE_RUNNING: decode_state = 2;
pub const DECODE_READY: decode_state = 1;
#[derive(Copy, Clone)]
#[repr(C)]
pub struct decodestate {
    pub state: decode_state,
    pub new_stream: bool,
    pub mutex: pthread_mutex_t,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct streamstate {
    pub state: stream_state,
    pub disconnect: disconnect_code,
    pub header: *mut libc::c_char,
    pub header_len: size_t,
    pub sent_headers: bool,
    pub cont_wait: bool,
    pub bytes: u64_t,
    pub threshold: libc::c_uint,
    pub meta_interval: u32_t,
    pub meta_next: u32_t,
    pub meta_left: u32_t,
    pub meta_send: bool,
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct handler {
    pub opcode: [libc::c_char; 5],
    pub handler: Option<unsafe extern "C" fn(_: *mut u8_t, _: libc::c_int)
                            -> ()>,
}
// guids we don't use
// S:C:Commands
#[derive(Copy, Clone)]
#[repr(C, packed)]
pub struct serv_packet {
    pub opcode: [libc::c_char; 4],
    pub server_ip: u32_t,
}
// possible sync group
// S:P:Squeezebox2
#[derive(Copy, Clone)]
#[repr(C, packed)]
pub struct setd_packet {
    pub opcode: [libc::c_char; 4],
    pub id: u8_t,
    pub data: [libc::c_char; 0],
}
// char metadata[]
// S:N:Slimproto _http_setting_handler
#[derive(Copy, Clone)]
#[repr(C, packed)]
pub struct SETD_header {
    pub opcode: [libc::c_char; 4],
    pub length: u32_t,
    pub id: u8_t,
}
// S:P:Squeezebox2
#[derive(Copy, Clone)]
#[repr(C, packed)]
pub struct audg_packet {
    pub opcode: [libc::c_char; 4],
    pub old_gainL: u32_t,
    pub old_gainR: u32_t,
    pub adjust: u8_t,
    pub preamp: u8_t,
    pub gainL: u32_t,
    pub gainR: u32_t,
}
//char request_string[];
// S:P:Squeezebox2
#[derive(Copy, Clone)]
#[repr(C, packed)]
pub struct aude_packet {
    pub opcode: [libc::c_char; 4],
    pub enable_spdif: u8_t,
    pub enable_dac: u8_t,
}
// codec open - this is an extension to slimproto to allow the server to read the header and then return decode params
#[derive(Copy, Clone)]
#[repr(C, packed)]
pub struct codc_packet {
    pub opcode: [libc::c_char; 4],
    pub format: u8_t,
    pub pcm_sample_size: u8_t,
    pub pcm_sample_rate: u8_t,
    pub pcm_channels: u8_t,
    pub pcm_endianness: u8_t,
}
// squence ids - unused
// S:P:Squeezebox2
#[derive(Copy, Clone)]
#[repr(C, packed)]
pub struct cont_packet {
    pub opcode: [libc::c_char; 4],
    pub metaint: u32_t,
    pub loop_0: u8_t,
}
// data
// from S:P:Squeezebox stream_s
#[derive(Copy, Clone)]
#[repr(C, packed)]
pub struct strm_packet {
    pub opcode: [libc::c_char; 4],
    pub command: libc::c_char,
    pub autostart: u8_t,
    pub format: u8_t,
    pub pcm_sample_size: u8_t,
    pub pcm_sample_rate: u8_t,
    pub pcm_channels: u8_t,
    pub pcm_endianness: u8_t,
    pub threshold: u8_t,
    pub spdif_enable: u8_t,
    pub transition_period: u8_t,
    pub transition_type: u8_t,
    pub flags: u8_t,
    pub output_threshold: u8_t,
    pub slaves: u8_t,
    pub replay_gain: u32_t,
    pub server_port: u16_t,
    pub server_ip: u32_t,
}
/* 
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *  
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
// packet formats for slimproto
// from S:N:Slimproto _hello_handler
#[derive(Copy, Clone)]
#[repr(C, packed)]
pub struct HELO_packet {
    pub opcode: [libc::c_char; 4],
    pub length: u32_t,
    pub deviceid: u8_t,
    pub revision: u8_t,
    pub mac: [u8_t; 6],
    pub uuid: [u8_t; 16],
    pub wlan_channellist: u16_t,
    pub bytes_received_H: u32_t,
    pub bytes_received_L: u32_t,
    pub lang: [libc::c_char; 2],
}
#[derive(Copy, Clone)]
#[repr(C)]
pub struct codec {
    pub id: libc::c_char,
    pub types: *mut libc::c_char,
    pub min_read_bytes: libc::c_uint,
    pub min_space: libc::c_uint,
    pub open: Option<unsafe extern "C" fn(_: u8_t, _: u8_t, _: u8_t, _: u8_t)
                         -> ()>,
    pub close: Option<unsafe extern "C" fn() -> ()>,
    pub decode: Option<unsafe extern "C" fn() -> decode_state>,
}
/* 
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *  
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additions (c) Paul Hermann, 2015-2017 under the same license terms
 *   -Control of Raspberry pi GPIO for amplifier power
 *   -Launch script on power status change from LMS
 */
static mut loglevel: log_level = lERROR;
// 3483
static mut sock: sockfd = -(1 as libc::c_int);
static mut slimproto_ip: in_addr_t = 0 as libc::c_int as in_addr_t;
#[no_mangle]
pub static mut wake_e: libc::c_int = 0;
static mut status: C2RustUnnamed_0 =
    C2RustUnnamed_0{updated: 0,
                    stream_start: 0,
                    stream_full: 0,
                    stream_size: 0,
                    stream_bytes: 0,
                    output_full: 0,
                    output_size: 0,
                    frames_played: 0,
                    device_frames: 0,
                    current_sample_rate: 0,
                    last: 0,
                    stream_state: STOPPED,};
#[no_mangle]
pub static mut autostart: libc::c_int = 0;
#[no_mangle]
pub static mut sentSTMu: bool = false;
#[no_mangle]
pub static mut sentSTMo: bool = false;
#[no_mangle]
pub static mut sentSTMl: bool = false;
#[no_mangle]
pub static mut new_server: u32_t = 0;
#[no_mangle]
pub static mut new_server_cap: *mut libc::c_char =
    0 as *const libc::c_char as *mut libc::c_char;
#[no_mangle]
pub static mut player_name: [libc::c_char; 65] =
    [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
#[no_mangle]
pub static mut name_file: *const libc::c_char = 0 as *const libc::c_char;
#[no_mangle]
pub unsafe extern "C" fn send_packet(mut packet: *mut u8_t, mut len: size_t) {
    let mut ptr: *mut u8_t = packet; // squeezeplay
    let mut try_0: libc::c_uint = 0 as libc::c_int as libc::c_uint;
    let mut n: ssize_t = 0;
    while len != 0 {
        n =
            send(sock, ptr as *const libc::c_void, len,
                 MSG_NOSIGNAL as libc::c_int);
        if n <= 0 as libc::c_int as libc::c_long {
            if n < 0 as libc::c_int as libc::c_long &&
                   *__errno_location() == 11 as libc::c_int &&
                   try_0 < 10 as libc::c_int as libc::c_uint {
                if loglevel as libc::c_uint >=
                       lDEBUG as libc::c_int as libc::c_uint {
                    try_0 = try_0.wrapping_add(1);
                    logprint(b"%s %s:%d retrying (%d) writing to socket\n\x00"
                                 as *const u8 as *const libc::c_char,
                             logtime(),
                             (*::std::mem::transmute::<&[u8; 12],
                                                       &[libc::c_char; 12]>(b"send_packet\x00")).as_ptr(),
                             104 as libc::c_int, try_0);
                }
                usleep(1000 as libc::c_int as __useconds_t);
            } else {
                if loglevel as libc::c_uint >=
                       lINFO as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d failed writing to socket: %s\n\x00" as
                                 *const u8 as *const libc::c_char, logtime(),
                             (*::std::mem::transmute::<&[u8; 12],
                                                       &[libc::c_char; 12]>(b"send_packet\x00")).as_ptr(),
                             108 as libc::c_int,
                             strerror(*__errno_location()));
                }
                return
            }
        } else {
            ptr = ptr.offset(n as isize);
            len =
                (len as libc::c_ulong).wrapping_sub(n as libc::c_ulong) as
                    size_t as size_t
        }
    };
}
unsafe extern "C" fn sendHELO(mut reconnect: bool,
                              mut fixed_cap: *const libc::c_char,
                              mut var_cap: *const libc::c_char,
                              mut mac: *mut u8_t) {
    let mut base_cap: *const libc::c_char = 0 as *const libc::c_char;
    let mut pkt: HELO_packet =
        HELO_packet{opcode: [0; 4],
                    length: 0,
                    deviceid: 0,
                    revision: 0,
                    mac: [0; 6],
                    uuid: [0; 16],
                    wlan_channellist: 0,
                    bytes_received_H: 0,
                    bytes_received_L: 0,
                    lang: [0; 2],};
    base_cap =
        b"Model=squeezelite,AccuratePlayPoints=1,HasDigitalOut=1,HasPolarityInversion=1,Firmware=v1.9.7-1223\x00"
            as *const u8 as *const libc::c_char;
    memset(&mut pkt as *mut HELO_packet as *mut libc::c_void,
           0 as libc::c_int,
           ::std::mem::size_of::<HELO_packet>() as libc::c_ulong);
    memcpy(&mut pkt.opcode as *mut [libc::c_char; 4] as *mut libc::c_void,
           b"HELO\x00" as *const u8 as *const libc::c_char as
               *const libc::c_void, 4 as libc::c_int as libc::c_ulong);
    pkt.length =
        htonl((::std::mem::size_of::<HELO_packet>() as
                   libc::c_ulong).wrapping_sub(8 as libc::c_int as
                                                   libc::c_ulong).wrapping_add(strlen(base_cap)).wrapping_add(strlen(fixed_cap)).wrapping_add(strlen(var_cap))
                  as uint32_t);
    pkt.deviceid = 12 as libc::c_int as u8_t;
    pkt.revision = 0 as libc::c_int as u8_t;
    packn(&mut pkt.wlan_channellist,
          if reconnect as libc::c_int != 0 {
              0x4000 as libc::c_int
          } else { 0 as libc::c_int } as u16_t);
    packN(&mut pkt.bytes_received_H,
          (status.stream_bytes >> 32 as libc::c_int) as u32_t);
    packN(&mut pkt.bytes_received_L,
          (status.stream_bytes & 0xffffffff as libc::c_uint as libc::c_ulong)
              as u32_t);
    memcpy(pkt.mac.as_mut_ptr() as *mut libc::c_void,
           mac as *const libc::c_void, 6 as libc::c_int as libc::c_ulong);
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d mac: %02x:%02x:%02x:%02x:%02x:%02x\n\x00" as
                     *const u8 as *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 9],
                                           &[libc::c_char; 9]>(b"sendHELO\x00")).as_ptr(),
                 142 as libc::c_int,
                 pkt.mac[0 as libc::c_int as usize] as libc::c_int,
                 pkt.mac[1 as libc::c_int as usize] as libc::c_int,
                 pkt.mac[2 as libc::c_int as usize] as libc::c_int,
                 pkt.mac[3 as libc::c_int as usize] as libc::c_int,
                 pkt.mac[4 as libc::c_int as usize] as libc::c_int,
                 pkt.mac[5 as libc::c_int as usize] as libc::c_int);
    }
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d cap: %s%s%s\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 9],
                                           &[libc::c_char; 9]>(b"sendHELO\x00")).as_ptr(),
                 144 as libc::c_int, base_cap, fixed_cap, var_cap);
    }
    send_packet(&mut pkt as *mut HELO_packet as *mut u8_t,
                ::std::mem::size_of::<HELO_packet>() as libc::c_ulong);
    send_packet(base_cap as *mut u8_t, strlen(base_cap));
    send_packet(fixed_cap as *mut u8_t, strlen(fixed_cap));
    send_packet(var_cap as *mut u8_t, strlen(var_cap));
}
unsafe extern "C" fn sendSTAT(mut event: *const libc::c_char,
                              mut server_timestamp: u32_t) {
    let mut pkt: STAT_packet =
        STAT_packet{opcode: [0; 4],
                    length: 0,
                    event: 0,
                    num_crlf: 0,
                    mas_initialized: 0,
                    mas_mode: 0,
                    stream_buffer_size: 0,
                    stream_buffer_fullness: 0,
                    bytes_received_H: 0,
                    bytes_received_L: 0,
                    signal_strength: 0,
                    jiffies: 0,
                    output_buffer_size: 0,
                    output_buffer_fullness: 0,
                    elapsed_seconds: 0,
                    voltage: 0,
                    elapsed_milliseconds: 0,
                    server_timestamp: 0,
                    error_code: 0,};
    let mut now: u32_t = gettime_ms();
    let mut ms_played: u32_t = 0;
    if status.current_sample_rate != 0 && status.frames_played != 0 &&
           status.frames_played > status.device_frames {
        ms_played =
            (status.frames_played.wrapping_sub(status.device_frames) as
                 u64_t).wrapping_mul(1000 as libc::c_int as
                                         u64_t).wrapping_div(status.current_sample_rate
                                                                 as u64_t) as
                u32_t;
        if now > status.updated {
            ms_played =
                (ms_played as
                     libc::c_uint).wrapping_add(now.wrapping_sub(status.updated))
                    as u32_t as u32_t
        }
        if loglevel as libc::c_uint >= lSDEBUG as libc::c_int as libc::c_uint
           {
            logprint(b"%s %s:%d ms_played: %u (frames_played: %u device_frames: %u)\n\x00"
                         as *const u8 as *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 9],
                                               &[libc::c_char; 9]>(b"sendSTAT\x00")).as_ptr(),
                     160 as libc::c_int, ms_played, status.frames_played,
                     status.device_frames);
        }
    } else if status.frames_played != 0 && now > status.stream_start {
        ms_played = now.wrapping_sub(status.stream_start);
        if loglevel as libc::c_uint >= lSDEBUG as libc::c_int as libc::c_uint
           {
            logprint(b"%s %s:%d ms_played: %u using elapsed time (frames_played: %u device_frames: %u)\n\x00"
                         as *const u8 as *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 9],
                                               &[libc::c_char; 9]>(b"sendSTAT\x00")).as_ptr(),
                     163 as libc::c_int, ms_played, status.frames_played,
                     status.device_frames);
        }
    } else {
        if loglevel as libc::c_uint >= lSDEBUG as libc::c_int as libc::c_uint
           {
            logprint(b"%s %s:%d ms_played: 0\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 9],
                                               &[libc::c_char; 9]>(b"sendSTAT\x00")).as_ptr(),
                     165 as libc::c_int);
        }
        ms_played = 0 as libc::c_int as u32_t
    }
    memset(&mut pkt as *mut STAT_packet as *mut libc::c_void,
           0 as libc::c_int,
           ::std::mem::size_of::<STAT_packet>() as libc::c_ulong);
    memcpy(&mut pkt.opcode as *mut [libc::c_char; 4] as *mut libc::c_void,
           b"STAT\x00" as *const u8 as *const libc::c_char as
               *const libc::c_void, 4 as libc::c_int as libc::c_ulong);
    pkt.length =
        htonl((::std::mem::size_of::<STAT_packet>() as
                   libc::c_ulong).wrapping_sub(8 as libc::c_int as
                                                   libc::c_ulong) as
                  uint32_t);
    memcpy(&mut pkt.event as *mut u32_t as *mut libc::c_void,
           event as *const libc::c_void, 4 as libc::c_int as libc::c_ulong);
    // num_crlf
	// mas_initialized; mas_mode;
    packN(&mut pkt.stream_buffer_fullness, status.stream_full);
    packN(&mut pkt.stream_buffer_size, status.stream_size);
    packN(&mut pkt.bytes_received_H,
          (status.stream_bytes >> 32 as libc::c_int) as u32_t);
    packN(&mut pkt.bytes_received_L,
          (status.stream_bytes & 0xffffffff as libc::c_uint as libc::c_ulong)
              as u32_t);
    pkt.signal_strength = 0xffff as libc::c_int as u16_t;
    packN(&mut pkt.jiffies, now);
    packN(&mut pkt.output_buffer_size, status.output_size);
    packN(&mut pkt.output_buffer_fullness, status.output_full);
    packN(&mut pkt.elapsed_seconds,
          ms_played.wrapping_div(1000 as libc::c_int as libc::c_uint));
    // voltage;
    packN(&mut pkt.elapsed_milliseconds,
          ms_played); // keep this is server format - don't unpack/pack
    pkt.server_timestamp = server_timestamp;
    // error_code;
    if loglevel as libc::c_uint >= lDEBUG as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d STAT: %s\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 9],
                                           &[libc::c_char; 9]>(b"sendSTAT\x00")).as_ptr(),
                 189 as libc::c_int,
                 event); // id 0 is playername S:P:Squeezebox2
    } // STMt replay_gain is no longer used to track latency, but support it
    if loglevel as libc::c_uint == lSDEBUG as libc::c_int as libc::c_uint {
        if loglevel as libc::c_uint >= lSDEBUG as libc::c_int as libc::c_uint
           {
            logprint(b"%s %s:%d received bytesL: %u streambuf: %u outputbuf: %u calc elapsed: %u real elapsed: %u (diff: %d) device: %u delay: %d\n\x00"
                         as *const u8 as *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 9],
                                               &[libc::c_char; 9]>(b"sendSTAT\x00")).as_ptr(),
                     194 as libc::c_int, status.stream_bytes as u32_t,
                     status.stream_full, status.output_full, ms_played,
                     now.wrapping_sub(status.stream_start),
                     ms_played.wrapping_sub(now).wrapping_add(status.stream_start),
                     status.device_frames.wrapping_mul(1000 as libc::c_int as
                                                           libc::c_uint).wrapping_div(status.current_sample_rate),
                     now.wrapping_sub(status.updated)); // keep in network byte order
        }
    } // keep in network byte order
    send_packet(&mut pkt as *mut STAT_packet as *mut u8_t,
                ::std::mem::size_of::<STAT_packet>() as libc::c_ulong);
}
unsafe extern "C" fn sendDSCO(mut disconnect: disconnect_code) {
    let mut pkt: DSCO_packet =
        DSCO_packet{opcode: [0; 4], length: 0, reason: 0,};
    memset(&mut pkt as *mut DSCO_packet as *mut libc::c_void,
           0 as libc::c_int,
           ::std::mem::size_of::<DSCO_packet>() as libc::c_ulong);
    memcpy(&mut pkt.opcode as *mut [libc::c_char; 4] as *mut libc::c_void,
           b"DSCO\x00" as *const u8 as *const libc::c_char as
               *const libc::c_void, 4 as libc::c_int as libc::c_ulong);
    pkt.length =
        htonl((::std::mem::size_of::<DSCO_packet>() as
                   libc::c_ulong).wrapping_sub(8 as libc::c_int as
                                                   libc::c_ulong) as
                  uint32_t);
    pkt.reason =
        (disconnect as libc::c_uint & 0xff as libc::c_int as libc::c_uint) as
            u8_t;
    if loglevel as libc::c_uint >= lDEBUG as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d DSCO: %d\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 9],
                                           &[libc::c_char; 9]>(b"sendDSCO\x00")).as_ptr(),
                 208 as libc::c_int, disconnect as libc::c_uint);
    }
    send_packet(&mut pkt as *mut DSCO_packet as *mut u8_t,
                ::std::mem::size_of::<DSCO_packet>() as libc::c_ulong);
}
unsafe extern "C" fn sendRESP(mut header: *const libc::c_char,
                              mut len: size_t) {
    let mut pkt_header: RESP_header = RESP_header{opcode: [0; 4], length: 0,};
    memset(&mut pkt_header as *mut RESP_header as *mut libc::c_void,
           0 as libc::c_int,
           ::std::mem::size_of::<RESP_header>() as libc::c_ulong);
    memcpy(&mut pkt_header.opcode as *mut [libc::c_char; 4] as
               *mut libc::c_void,
           b"RESP\x00" as *const u8 as *const libc::c_char as
               *const libc::c_void, 4 as libc::c_int as libc::c_ulong);
    pkt_header.length =
        htonl((::std::mem::size_of::<RESP_header>() as
                   libc::c_ulong).wrapping_add(len).wrapping_sub(8 as
                                                                     libc::c_int
                                                                     as
                                                                     libc::c_ulong)
                  as uint32_t);
    if loglevel as libc::c_uint >= lDEBUG as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d RESP\n\x00" as *const u8 as *const libc::c_char,
                 logtime(),
                 (*::std::mem::transmute::<&[u8; 9],
                                           &[libc::c_char; 9]>(b"sendRESP\x00")).as_ptr(),
                 220 as libc::c_int);
    }
    send_packet(&mut pkt_header as *mut RESP_header as *mut u8_t,
                ::std::mem::size_of::<RESP_header>() as libc::c_ulong);
    send_packet(header as *mut u8_t, len);
}
unsafe extern "C" fn sendMETA(mut meta: *const libc::c_char,
                              mut len: size_t) {
    let mut pkt_header: META_header = META_header{opcode: [0; 4], length: 0,};
    memset(&mut pkt_header as *mut META_header as *mut libc::c_void,
           0 as libc::c_int,
           ::std::mem::size_of::<META_header>() as libc::c_ulong);
    memcpy(&mut pkt_header.opcode as *mut [libc::c_char; 4] as
               *mut libc::c_void,
           b"META\x00" as *const u8 as *const libc::c_char as
               *const libc::c_void, 4 as libc::c_int as libc::c_ulong);
    pkt_header.length =
        htonl((::std::mem::size_of::<META_header>() as
                   libc::c_ulong).wrapping_add(len).wrapping_sub(8 as
                                                                     libc::c_int
                                                                     as
                                                                     libc::c_ulong)
                  as uint32_t);
    if loglevel as libc::c_uint >= lDEBUG as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d META\n\x00" as *const u8 as *const libc::c_char,
                 logtime(),
                 (*::std::mem::transmute::<&[u8; 9],
                                           &[libc::c_char; 9]>(b"sendMETA\x00")).as_ptr(),
                 233 as libc::c_int);
    }
    send_packet(&mut pkt_header as *mut META_header as *mut u8_t,
                ::std::mem::size_of::<META_header>() as libc::c_ulong);
    send_packet(meta as *mut u8_t, len);
}
unsafe extern "C" fn sendSETDName(mut name: *const libc::c_char) {
    let mut pkt_header: SETD_header =
        SETD_header{opcode: [0; 4], length: 0, id: 0,};
    memset(&mut pkt_header as *mut SETD_header as *mut libc::c_void,
           0 as libc::c_int,
           ::std::mem::size_of::<SETD_header>() as libc::c_ulong);
    memcpy(&mut pkt_header.opcode as *mut [libc::c_char; 4] as
               *mut libc::c_void,
           b"SETD\x00" as *const u8 as *const libc::c_char as
               *const libc::c_void, 4 as libc::c_int as libc::c_ulong);
    pkt_header.id = 0 as libc::c_int as u8_t;
    pkt_header.length =
        htonl((::std::mem::size_of::<SETD_header>() as
                   libc::c_ulong).wrapping_add(strlen(name)).wrapping_add(1 as
                                                                              libc::c_int
                                                                              as
                                                                              libc::c_ulong).wrapping_sub(8
                                                                                                              as
                                                                                                              libc::c_int
                                                                                                              as
                                                                                                              libc::c_ulong)
                  as uint32_t);
    if loglevel as libc::c_uint >= lDEBUG as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d set playername: %s\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 13],
                                           &[libc::c_char; 13]>(b"sendSETDName\x00")).as_ptr(),
                 248 as libc::c_int, name);
    }
    send_packet(&mut pkt_header as *mut SETD_header as *mut u8_t,
                ::std::mem::size_of::<SETD_header>() as libc::c_ulong);
    send_packet(name as *mut u8_t,
                strlen(name).wrapping_add(1 as libc::c_int as libc::c_ulong));
}
unsafe extern "C" fn process_strm(mut pkt: *mut u8_t, mut len: libc::c_int) {
    let mut strm: *mut strm_packet = pkt as *mut strm_packet;
    if loglevel as libc::c_uint >= lDEBUG as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d strm command %c\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 13],
                                           &[libc::c_char; 13]>(b"process_strm\x00")).as_ptr(),
                 274 as libc::c_int, (*strm).command as libc::c_int);
    }
    let mut current_block_78: u64;
    match (*strm).command as libc::c_int {
        116 => {
            sendSTAT(b"STMt\x00" as *const u8 as *const libc::c_char,
                     (*strm).replay_gain);
        }
        113 => {
            decode_flush();
            output_flush();
            status.frames_played = 0 as libc::c_int as u32_t;
            stream_disconnect();
            sendSTAT(b"STMf\x00" as *const u8 as *const libc::c_char,
                     0 as libc::c_int as u32_t);
            buf_flush(streambuf);
        }
        102 => {
            decode_flush();
            output_flush();
            status.frames_played = 0 as libc::c_int as u32_t;
            if stream_disconnect() {
                sendSTAT(b"STMf\x00" as *const u8 as *const libc::c_char,
                         0 as libc::c_int as u32_t);
            }
            buf_flush(streambuf);
        }
        112 => {
            let mut interval: libc::c_uint =
                unpackN(&mut (*strm).replay_gain);
            pthread_mutex_lock(&mut (*outputbuf).mutex);
            output.c2rust_unnamed.pause_frames =
                interval.wrapping_mul(status.current_sample_rate).wrapping_div(1000
                                                                                   as
                                                                                   libc::c_int
                                                                                   as
                                                                                   libc::c_uint);
            if interval != 0 {
                output.state = OUTPUT_PAUSE_FRAMES
            } else {
                output.state = OUTPUT_STOPPED;
                output.stop_time = gettime_ms()
            }
            pthread_mutex_unlock(&mut (*outputbuf).mutex);
            if interval == 0 {
                sendSTAT(b"STMp\x00" as *const u8 as *const libc::c_char,
                         0 as libc::c_int as u32_t);
            }
            if loglevel as libc::c_uint >=
                   lDEBUG as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d pause interval: %u\n\x00" as *const u8 as
                             *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 13],
                                                   &[libc::c_char; 13]>(b"process_strm\x00")).as_ptr(),
                         310 as libc::c_int, interval);
            }
        }
        97 => {
            let mut interval_0: libc::c_uint =
                unpackN(&mut (*strm).replay_gain);
            pthread_mutex_lock(&mut (*outputbuf).mutex);
            output.c2rust_unnamed.skip_frames =
                interval_0.wrapping_mul(status.current_sample_rate).wrapping_div(1000
                                                                                     as
                                                                                     libc::c_int
                                                                                     as
                                                                                     libc::c_uint);
            output.state = OUTPUT_SKIP_FRAMES;
            pthread_mutex_unlock(&mut (*outputbuf).mutex);
            if loglevel as libc::c_uint >=
                   lDEBUG as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d skip ahead interval: %u\n\x00" as
                             *const u8 as *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 13],
                                                   &[libc::c_char; 13]>(b"process_strm\x00")).as_ptr(),
                         320 as libc::c_int, interval_0);
            }
        }
        117 => {
            let mut jiffies: libc::c_uint = unpackN(&mut (*strm).replay_gain);
            pthread_mutex_lock(&mut (*outputbuf).mutex);
            output.state =
                if jiffies != 0 {
                    OUTPUT_START_AT as libc::c_int
                } else { OUTPUT_RUNNING as libc::c_int } as output_state;
            output.c2rust_unnamed.start_at = jiffies;
            pthread_mutex_unlock(&mut (*outputbuf).mutex);
            if loglevel as libc::c_uint >=
                   lDEBUG as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d unpause at: %u now: %u\n\x00" as *const u8
                             as *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 13],
                                                   &[libc::c_char; 13]>(b"process_strm\x00")).as_ptr(),
                         331 as libc::c_int, jiffies, gettime_ms());
            }
            sendSTAT(b"STMr\x00" as *const u8 as *const libc::c_char,
                     0 as libc::c_int as u32_t);
        }
        115 => {
            let mut header_len: libc::c_uint =
                (len as
                     libc::c_ulong).wrapping_sub(::std::mem::size_of::<strm_packet>()
                                                     as libc::c_ulong) as
                    libc::c_uint;
            let mut header: *mut libc::c_char =
                pkt.offset(::std::mem::size_of::<strm_packet>() as
                               libc::c_ulong as isize) as *mut libc::c_char;
            let mut ip: in_addr_t = (*strm).server_ip;
            let mut port: u16_t = (*strm).server_port;
            if ip == 0 as libc::c_int as libc::c_uint { ip = slimproto_ip }
            if loglevel as libc::c_uint >=
                   lDEBUG as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d strm s autostart: %c transition period: %u transition type: %u codec: %c\n\x00"
                             as *const u8 as *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 13],
                                                   &[libc::c_char; 13]>(b"process_strm\x00")).as_ptr(),
                         344 as libc::c_int, (*strm).autostart as libc::c_int,
                         (*strm).transition_period as libc::c_int,
                         (*strm).transition_type as libc::c_int - '0' as i32,
                         (*strm).format as libc::c_int);
            }
            autostart = (*strm).autostart as libc::c_int - '0' as i32;
            sendSTAT(b"STMf\x00" as *const u8 as *const libc::c_char,
                     0 as libc::c_int as u32_t);
            if header_len >
                   (4096 as libc::c_int - 1 as libc::c_int) as libc::c_uint {
                if loglevel as libc::c_uint >=
                       lWARN as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d header too long: %u\n\x00" as
                                 *const u8 as *const libc::c_char, logtime(),
                             (*::std::mem::transmute::<&[u8; 13],
                                                       &[libc::c_char; 13]>(b"process_strm\x00")).as_ptr(),
                             350 as libc::c_int, header_len);
                }
            } else {
                if (*strm).format as libc::c_int != '?' as i32 {
                    codec_open((*strm).format, (*strm).pcm_sample_size,
                               (*strm).pcm_sample_rate, (*strm).pcm_channels,
                               (*strm).pcm_endianness);
                    current_block_78 = 12758904613967585247;
                } else if autostart >= 2 as libc::c_int {
                    // extension to slimproto to allow server to detect codec from response header and send back in codc message
                    if loglevel as libc::c_uint >=
                           lDEBUG as libc::c_int as libc::c_uint {
                        logprint(b"%s %s:%d streaming unknown codec\n\x00" as
                                     *const u8 as *const libc::c_char,
                                 logtime(),
                                 (*::std::mem::transmute::<&[u8; 13],
                                                           &[libc::c_char; 13]>(b"process_strm\x00")).as_ptr(),
                                 357 as libc::c_int);
                    }
                    current_block_78 = 12758904613967585247;
                } else {
                    if loglevel as libc::c_uint >=
                           lWARN as libc::c_int as libc::c_uint {
                        logprint(b"%s %s:%d unknown codec requires autostart >= 2\n\x00"
                                     as *const u8 as *const libc::c_char,
                                 logtime(),
                                 (*::std::mem::transmute::<&[u8; 13],
                                                           &[libc::c_char; 13]>(b"process_strm\x00")).as_ptr(),
                                 359 as libc::c_int);
                    }
                    current_block_78 = 15587532755333643506;
                }
                match current_block_78 {
                    15587532755333643506 => { }
                    _ => {
                        if ip == 0x100007f as libc::c_int as libc::c_uint &&
                               port as libc::c_int == 0x9b0d as libc::c_int {
                            // extension to slimproto for LocalPlayer - header is filename not http header, don't expect cont
                            stream_file(header, header_len as size_t,
                                        ((*strm).threshold as libc::c_int *
                                             1024 as libc::c_int) as
                                            libc::c_uint);
                            autostart -= 2 as libc::c_int
                        } else {
                            stream_sock(ip, port, header,
                                        header_len as size_t,
                                        ((*strm).threshold as libc::c_int *
                                             1024 as libc::c_int) as
                                            libc::c_uint,
                                        autostart >= 2 as libc::c_int);
                        }
                        sendSTAT(b"STMc\x00" as *const u8 as
                                     *const libc::c_char,
                                 0 as libc::c_int as u32_t);
                        sentSTMl = 0 as libc::c_int != 0;
                        sentSTMo = sentSTMl;
                        sentSTMu = sentSTMo;
                        pthread_mutex_lock(&mut (*outputbuf).mutex);
                        output.threshold =
                            (*strm).output_threshold as libc::c_uint;
                        output.next_replay_gain =
                            unpackN(&mut (*strm).replay_gain);
                        output.fade_mode =
                            ((*strm).transition_type as libc::c_int -
                                 '0' as i32) as fade_mode;
                        output.fade_secs =
                            (*strm).transition_period as libc::c_uint;
                        output.invert =
                            (*strm).flags as libc::c_int & 0x3 as libc::c_int
                                == 0x3 as libc::c_int;
                        if loglevel as libc::c_uint >=
                               lDEBUG as libc::c_int as libc::c_uint {
                            logprint(b"%s %s:%d set fade mode: %u\n\x00" as
                                         *const u8 as *const libc::c_char,
                                     logtime(),
                                     (*::std::mem::transmute::<&[u8; 13],
                                                               &[libc::c_char; 13]>(b"process_strm\x00")).as_ptr(),
                                     377 as libc::c_int,
                                     output.fade_mode as libc::c_uint);
                        }
                        pthread_mutex_unlock(&mut (*outputbuf).mutex);
                    }
                }
            }
        }
        _ => {
            if loglevel as libc::c_uint >=
                   lWARN as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d unhandled strm %c\n\x00" as *const u8 as
                             *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 13],
                                                   &[libc::c_char; 13]>(b"process_strm\x00")).as_ptr(),
                         382 as libc::c_int, (*strm).command as libc::c_int);
            }
        }
    };
}
unsafe extern "C" fn process_cont(mut pkt: *mut u8_t, mut len: libc::c_int) {
    let mut cont: *mut cont_packet = pkt as *mut cont_packet;
    (*cont).metaint = unpackN(&mut (*cont).metaint);
    if loglevel as libc::c_uint >= lDEBUG as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d cont metaint: %u loop: %u\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 13],
                                           &[libc::c_char; 13]>(b"process_cont\x00")).as_ptr(),
                 391 as libc::c_int, (*cont).metaint,
                 (*cont).loop_0 as libc::c_int);
    }
    if autostart > 1 as libc::c_int {
        autostart -= 2 as libc::c_int;
        pthread_mutex_lock(&mut (*streambuf).mutex);
        if stream.state as libc::c_uint ==
               STREAMING_WAIT as libc::c_int as libc::c_uint {
            stream.state = STREAMING_BUFFERING;
            stream.meta_next = (*cont).metaint;
            stream.meta_interval = stream.meta_next
        }
        pthread_mutex_unlock(&mut (*streambuf).mutex);
        wake_controller();
    };
}
unsafe extern "C" fn process_codc(mut pkt: *mut u8_t, mut len: libc::c_int) {
    let mut codc: *mut codc_packet = pkt as *mut codc_packet;
    if loglevel as libc::c_uint >= lDEBUG as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d codc: %c\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 13],
                                           &[libc::c_char; 13]>(b"process_codc\x00")).as_ptr(),
                 408 as libc::c_int, (*codc).format as libc::c_int);
    }
    codec_open((*codc).format, (*codc).pcm_sample_size,
               (*codc).pcm_sample_rate, (*codc).pcm_channels,
               (*codc).pcm_endianness);
}
unsafe extern "C" fn process_aude(mut pkt: *mut u8_t, mut len: libc::c_int) {
    let mut aude: *mut aude_packet = pkt as *mut aude_packet;
    if loglevel as libc::c_uint >= lDEBUG as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d enable spdif: %d dac: %d\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 13],
                                           &[libc::c_char; 13]>(b"process_aude\x00")).as_ptr(),
                 415 as libc::c_int, (*aude).enable_spdif as libc::c_int,
                 (*aude).enable_dac as libc::c_int);
    }
    pthread_mutex_lock(&mut (*outputbuf).mutex);
    if (*aude).enable_spdif == 0 &&
           output.state as libc::c_int != OUTPUT_OFF as libc::c_int {
        output.state = OUTPUT_OFF
    }
    if (*aude).enable_spdif as libc::c_int != 0 &&
           output.state as libc::c_int == OUTPUT_OFF as libc::c_int &&
           output.idle_to == 0 {
        output.state = OUTPUT_STOPPED;
        output.stop_time = gettime_ms()
    }
    pthread_mutex_unlock(&mut (*outputbuf).mutex);
}
unsafe extern "C" fn process_audg(mut pkt: *mut u8_t, mut len: libc::c_int) {
    let mut audg: *mut audg_packet = pkt as *mut audg_packet;
    (*audg).gainL = unpackN(&mut (*audg).gainL);
    (*audg).gainR = unpackN(&mut (*audg).gainR);
    if loglevel as libc::c_uint >= lDEBUG as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d audg gainL: %u gainR: %u adjust: %u\n\x00" as
                     *const u8 as *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 13],
                                           &[libc::c_char; 13]>(b"process_audg\x00")).as_ptr(),
                 433 as libc::c_int, (*audg).gainL, (*audg).gainR,
                 (*audg).adjust as libc::c_int);
    }
    set_volume(if (*audg).adjust as libc::c_int != 0 {
                   (*audg).gainL
               } else { 0x10000 as libc::c_int as libc::c_uint },
               if (*audg).adjust as libc::c_int != 0 {
                   (*audg).gainR
               } else { 0x10000 as libc::c_int as libc::c_uint });
}
unsafe extern "C" fn process_setd(mut pkt: *mut u8_t, mut len: libc::c_int) {
    let mut setd: *mut setd_packet = pkt as *mut setd_packet;
    // handle player name query and change
    if (*setd).id as libc::c_int == 0 as libc::c_int {
        if len == 5 as libc::c_int {
            if strlen(player_name.as_mut_ptr()) != 0 {
                sendSETDName(player_name.as_mut_ptr());
            }
        } else if len > 5 as libc::c_int {
            strncpy(player_name.as_mut_ptr(), (*setd).data.as_mut_ptr(),
                    64 as libc::c_int as libc::c_ulong);
            player_name[64 as libc::c_int as usize] =
                '\u{0}' as i32 as libc::c_char;
            if loglevel as libc::c_uint >=
                   lINFO as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d set name: %s\n\x00" as *const u8 as
                             *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 13],
                                                   &[libc::c_char; 13]>(b"process_setd\x00")).as_ptr(),
                         450 as libc::c_int, (*setd).data.as_mut_ptr());
            }
            // confirm change to server
            sendSETDName((*setd).data.as_mut_ptr());
            // write name to name_file if -N option set
            if !name_file.is_null() {
                let mut fp: *mut FILE =
                    fopen(name_file,
                          b"w\x00" as *const u8 as
                              *const libc::c_char); // length pack 'n'
                if !fp.is_null() {
                    if loglevel as libc::c_uint >=
                           lINFO as libc::c_int as libc::c_uint {
                        logprint(b"%s %s:%d storing name in %s\n\x00" as
                                     *const u8 as *const libc::c_char,
                                 logtime(),
                                 (*::std::mem::transmute::<&[u8; 13],
                                                           &[libc::c_char; 13]>(b"process_setd\x00")).as_ptr(),
                                 457 as libc::c_int, name_file);
                    }
                    fputs(player_name.as_mut_ptr(), fp);
                    fclose(fp);
                } else if loglevel as libc::c_uint >=
                              lWARN as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d unable to store new name in %s\n\x00"
                                 as *const u8 as *const libc::c_char,
                             logtime(),
                             (*::std::mem::transmute::<&[u8; 13],
                                                       &[libc::c_char; 13]>(b"process_setd\x00")).as_ptr(),
                             461 as libc::c_int, name_file);
                }
            }
        }
    };
}
unsafe extern "C" fn process_serv(mut pkt: *mut u8_t, mut len: libc::c_int) {
    let mut serv: *mut serv_packet = pkt as *mut serv_packet;
    let mut slimproto_port: libc::c_uint = 0 as libc::c_int as libc::c_uint;
    let mut squeezeserver: [libc::c_char; 22] =
        *::std::mem::transmute::<&[u8; 22],
                                 &mut [libc::c_char; 22]>(b"mysqueezebox.com:3483\x00");
    if *pkt.offset(4 as libc::c_int as isize) as libc::c_int ==
           0 as libc::c_int &&
           *pkt.offset(5 as libc::c_int as isize) as libc::c_int ==
               0 as libc::c_int &&
           *pkt.offset(6 as libc::c_int as isize) as libc::c_int ==
               0 as libc::c_int &&
           *pkt.offset(7 as libc::c_int as isize) as libc::c_int ==
               1 as libc::c_int {
        server_addr(squeezeserver.as_mut_ptr(), &mut new_server,
                    &mut slimproto_port);
    } else { new_server = (*serv).server_ip }
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d switch server\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 13],
                                           &[libc::c_char; 13]>(b"process_serv\x00")).as_ptr(),
                 483 as libc::c_int);
    }
    if (len as
            libc::c_ulong).wrapping_sub(::std::mem::size_of::<serv_packet>()
                                            as libc::c_ulong) ==
           10 as libc::c_int as libc::c_ulong {
        if new_server_cap.is_null() {
            new_server_cap =
                malloc((13 as libc::c_int + 10 as libc::c_int +
                            1 as libc::c_int) as libc::c_ulong) as
                    *mut libc::c_char
        }
        *new_server_cap.offset(0 as libc::c_int as isize) =
            '\u{0}' as i32 as libc::c_char;
        strcat(new_server_cap,
               b",SyncgroupID=\x00" as *const u8 as *const libc::c_char);
        strncat(new_server_cap,
                pkt.offset(::std::mem::size_of::<serv_packet>() as
                               libc::c_ulong as isize) as *const libc::c_char,
                10 as libc::c_int as libc::c_ulong);
    } else if !new_server_cap.is_null() {
        free(new_server_cap as *mut libc::c_void);
        new_server_cap = 0 as *mut libc::c_char
    };
}
static mut handlers: [handler; 8] =
    unsafe {
        [{
             let mut init =
                 handler{opcode: [115, 116, 114, 109, 0],
                         handler:
                             Some(process_strm as
                                      unsafe extern "C" fn(_: *mut u8_t,
                                                           _: libc::c_int)
                                          -> ()),};
             init
         },
         {
             let mut init =
                 handler{opcode: [99, 111, 110, 116, 0],
                         handler:
                             Some(process_cont as
                                      unsafe extern "C" fn(_: *mut u8_t,
                                                           _: libc::c_int)
                                          -> ()),};
             init
         },
         {
             let mut init =
                 handler{opcode: [99, 111, 100, 99, 0],
                         handler:
                             Some(process_codc as
                                      unsafe extern "C" fn(_: *mut u8_t,
                                                           _: libc::c_int)
                                          -> ()),};
             init
         },
         {
             let mut init =
                 handler{opcode: [97, 117, 100, 101, 0],
                         handler:
                             Some(process_aude as
                                      unsafe extern "C" fn(_: *mut u8_t,
                                                           _: libc::c_int)
                                          -> ()),};
             init
         },
         {
             let mut init =
                 handler{opcode: [97, 117, 100, 103, 0],
                         handler:
                             Some(process_audg as
                                      unsafe extern "C" fn(_: *mut u8_t,
                                                           _: libc::c_int)
                                          -> ()),};
             init
         },
         {
             let mut init =
                 handler{opcode: [115, 101, 116, 100, 0],
                         handler:
                             Some(process_setd as
                                      unsafe extern "C" fn(_: *mut u8_t,
                                                           _: libc::c_int)
                                          -> ()),};
             init
         },
         {
             let mut init =
                 handler{opcode: [115, 101, 114, 118, 0],
                         handler:
                             Some(process_serv as
                                      unsafe extern "C" fn(_: *mut u8_t,
                                                           _: libc::c_int)
                                          -> ()),};
             init
         },
         {
             let mut init = handler{opcode: [0, 0, 0, 0, 0], handler: None,};
             init
         }]
    };
unsafe extern "C" fn process(mut pack: *mut u8_t, mut len: libc::c_int) {
    let mut h: *mut handler = handlers.as_mut_ptr();
    while (*h).handler.is_some() &&
              strncmp(pack as *mut libc::c_char, (*h).opcode.as_mut_ptr(),
                      4 as libc::c_int as libc::c_ulong) != 0 {
        h = h.offset(1)
    }
    if (*h).handler.is_some() {
        if loglevel as libc::c_uint >= lDEBUG as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d %s\n\x00" as *const u8 as *const libc::c_char,
                     logtime(),
                     (*::std::mem::transmute::<&[u8; 8],
                                               &[libc::c_char; 8]>(b"process\x00")).as_ptr(),
                     521 as libc::c_int, (*h).opcode.as_mut_ptr());
        }
        (*h).handler.expect("non-null function pointer")(pack, len);
    } else {
        *pack.offset(4 as libc::c_int as isize) = '\u{0}' as i32 as u8_t;
        if loglevel as libc::c_uint >= lWARN as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d unhandled %s\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 8],
                                               &[libc::c_char; 8]>(b"process\x00")).as_ptr(),
                     525 as libc::c_int, pack as *mut libc::c_char);
        }
    };
}
static mut running: bool = false;
unsafe extern "C" fn slimproto_run() {
    static mut buffer: [u8_t; 4096] = [0; 4096];
    let mut expect: libc::c_int = 0 as libc::c_int;
    let mut got: libc::c_int = 0 as libc::c_int;
    let mut now: u32_t = 0;
    static mut last: u32_t = 0 as libc::c_int as u32_t;
    let mut ehandles: [pollfd; 2] =
        [pollfd{fd: 0, events: 0, revents: 0,}; 2];
    let mut timeouts: libc::c_int = 0 as libc::c_int;
    set_readwake_handles(ehandles.as_mut_ptr(), sock, wake_e);
    while running as libc::c_int != 0 && new_server == 0 {
        let mut wake: bool = 0 as libc::c_int != 0;
        let mut ev: event_type = EVENT_TIMEOUT;
        ev = wait_readwake(ehandles.as_mut_ptr(), 1000 as libc::c_int);
        if ev as libc::c_uint != EVENT_TIMEOUT as libc::c_int as libc::c_uint
           {
            if ev as libc::c_uint == EVENT_READ as libc::c_int as libc::c_uint
               {
                if expect > 0 as libc::c_int {
                    let mut n: libc::c_int =
                        recv(sock,
                             buffer.as_mut_ptr().offset(got as isize) as
                                 *mut libc::c_void, expect as size_t,
                             0 as libc::c_int) as libc::c_int;
                    if n <= 0 as libc::c_int {
                        if n < 0 as libc::c_int &&
                               *__errno_location() == 11 as libc::c_int {
                            continue ;
                        }
                        if loglevel as libc::c_uint >=
                               lINFO as libc::c_int as libc::c_uint {
                            logprint(b"%s %s:%d error reading from socket: %s\n\x00"
                                         as *const u8 as *const libc::c_char,
                                     logtime(),
                                     (*::std::mem::transmute::<&[u8; 14],
                                                               &[libc::c_char; 14]>(b"slimproto_run\x00")).as_ptr(),
                                     557 as libc::c_int,
                                     if n != 0 {
                                         strerror(*__errno_location()) as
                                             *const libc::c_char
                                     } else {
                                         b"closed\x00" as *const u8 as
                                             *const libc::c_char
                                     });
                        }
                        return
                    } else {
                        expect -= n;
                        got += n;
                        if expect == 0 as libc::c_int {
                            process(buffer.as_mut_ptr(), got);
                            got = 0 as libc::c_int
                        }
                    }
                } else if expect == 0 as libc::c_int {
                    let mut n_0: libc::c_int =
                        recv(sock,
                             buffer.as_mut_ptr().offset(got as isize) as
                                 *mut libc::c_void,
                             (2 as libc::c_int - got) as size_t,
                             0 as libc::c_int) as libc::c_int;
                    if n_0 <= 0 as libc::c_int {
                        if n_0 < 0 as libc::c_int &&
                               *__errno_location() == 11 as libc::c_int {
                            continue ;
                        }
                        if loglevel as libc::c_uint >=
                               lINFO as libc::c_int as libc::c_uint {
                            logprint(b"%s %s:%d error reading from socket: %s\n\x00"
                                         as *const u8 as *const libc::c_char,
                                     logtime(),
                                     (*::std::mem::transmute::<&[u8; 14],
                                                               &[libc::c_char; 14]>(b"slimproto_run\x00")).as_ptr(),
                                     572 as libc::c_int,
                                     if n_0 != 0 {
                                         strerror(*__errno_location()) as
                                             *const libc::c_char
                                     } else {
                                         b"closed\x00" as *const u8 as
                                             *const libc::c_char
                                     });
                        }
                        return
                    } else {
                        got += n_0;
                        if got == 2 as libc::c_int {
                            expect =
                                (buffer[0 as libc::c_int as usize] as
                                     libc::c_int) << 8 as libc::c_int |
                                    buffer[1 as libc::c_int as usize] as
                                        libc::c_int;
                            got = 0 as libc::c_int;
                            if expect > 4096 as libc::c_int {
                                logprint(b"%s %s:%d FATAL: slimproto packet too big: %d > %d\n\x00"
                                             as *const u8 as
                                             *const libc::c_char, logtime(),
                                         (*::std::mem::transmute::<&[u8; 14],
                                                                   &[libc::c_char; 14]>(b"slimproto_run\x00")).as_ptr(),
                                         580 as libc::c_int, expect,
                                         4096 as libc::c_int);
                                return
                            }
                        }
                    }
                } else {
                    logprint(b"%s %s:%d FATAL: negative expect\n\x00" as
                                 *const u8 as *const libc::c_char, logtime(),
                             (*::std::mem::transmute::<&[u8; 14],
                                                       &[libc::c_char; 14]>(b"slimproto_run\x00")).as_ptr(),
                             585 as libc::c_int);
                    return
                }
            }
            if ev as libc::c_uint == EVENT_WAKE as libc::c_int as libc::c_uint
               {
                wake = 1 as libc::c_int != 0
            }
            timeouts = 0 as libc::c_int
        } else {
            timeouts += 1;
            if timeouts > 35 as libc::c_int {
                // expect message from server every 5 seconds, but 30 seconds on mysb.com so timeout after 35 seconds
                if loglevel as libc::c_uint >=
                       lINFO as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d No messages from server - connection dead\n\x00"
                                 as *const u8 as *const libc::c_char,
                             logtime(),
                             (*::std::mem::transmute::<&[u8; 14],
                                                       &[libc::c_char; 14]>(b"slimproto_run\x00")).as_ptr(),
                             600 as libc::c_int);
                }
                return
            }
        }
        // update playback state when woken or every 100ms
        now = gettime_ms();
        if wake as libc::c_int != 0 ||
               now.wrapping_sub(last) > 100 as libc::c_int as libc::c_uint ||
               last > now {
            let mut _sendSTMs: bool = 0 as libc::c_int != 0;
            let mut _sendDSCO: bool = 0 as libc::c_int != 0;
            let mut _sendRESP: bool = 0 as libc::c_int != 0;
            let mut _sendMETA: bool = 0 as libc::c_int != 0;
            let mut _sendSTMd: bool = 0 as libc::c_int != 0;
            let mut _sendSTMt: bool = 0 as libc::c_int != 0;
            let mut _sendSTMl: bool = 0 as libc::c_int != 0;
            let mut _sendSTMu: bool = 0 as libc::c_int != 0;
            let mut _sendSTMo: bool = 0 as libc::c_int != 0;
            let mut _sendSTMn: bool = 0 as libc::c_int != 0;
            let mut _stream_disconnect: bool = 0 as libc::c_int != 0;
            let mut _start_output: bool = 0 as libc::c_int != 0;
            let mut _decode_state: decode_state = DECODE_STOPPED;
            let mut disconnect_code: disconnect_code = DISCONNECT_OK;
            static mut header: [libc::c_char; 4096] = [0; 4096];
            let mut header_len: size_t = 0 as libc::c_int as size_t;
            last = now;
            pthread_mutex_lock(&mut (*streambuf).mutex);
            status.stream_full = _buf_used(streambuf);
            status.stream_size = (*streambuf).size as u32_t;
            status.stream_bytes = stream.bytes;
            status.stream_state = stream.state;
            if stream.state as libc::c_uint ==
                   DISCONNECT as libc::c_int as libc::c_uint {
                disconnect_code = stream.disconnect;
                stream.state = STOPPED;
                _sendDSCO = 1 as libc::c_int != 0
            }
            if !stream.sent_headers &&
                   (stream.state as libc::c_uint ==
                        STREAMING_HTTP as libc::c_int as libc::c_uint ||
                        stream.state as libc::c_uint ==
                            STREAMING_WAIT as libc::c_int as libc::c_uint ||
                        stream.state as libc::c_uint ==
                            STREAMING_BUFFERING as libc::c_int as
                                libc::c_uint) {
                header_len = stream.header_len;
                memcpy(header.as_mut_ptr() as *mut libc::c_void,
                       stream.header as *const libc::c_void, header_len);
                _sendRESP = 1 as libc::c_int != 0;
                stream.sent_headers = 1 as libc::c_int != 0
            }
            if stream.meta_send {
                header_len = stream.header_len;
                memcpy(header.as_mut_ptr() as *mut libc::c_void,
                       stream.header as *const libc::c_void, header_len);
                _sendMETA = 1 as libc::c_int != 0;
                stream.meta_send = 0 as libc::c_int != 0
            }
            pthread_mutex_unlock(&mut (*streambuf).mutex);
            pthread_mutex_lock(&mut decode.mutex);
            if (status.stream_state as libc::c_uint ==
                    STREAMING_HTTP as libc::c_int as libc::c_uint ||
                    status.stream_state as libc::c_uint ==
                        STREAMING_FILE as libc::c_int as libc::c_uint ||
                    status.stream_state as libc::c_uint ==
                        DISCONNECT as libc::c_int as libc::c_uint &&
                        stream.disconnect as libc::c_uint ==
                            DISCONNECT_OK as libc::c_int as libc::c_uint) &&
                   !sentSTMl &&
                   decode.state as libc::c_uint ==
                       DECODE_READY as libc::c_int as libc::c_uint {
                if autostart == 0 as libc::c_int {
                    decode.state = DECODE_RUNNING;
                    _sendSTMl = 1 as libc::c_int != 0;
                    sentSTMl = 1 as libc::c_int != 0
                } else if autostart == 1 as libc::c_int {
                    decode.state = DECODE_RUNNING;
                    _start_output = 1 as libc::c_int != 0
                }
                // autostart 2 and 3 require cont to be received first
            }
            if decode.state as libc::c_uint ==
                   DECODE_COMPLETE as libc::c_int as libc::c_uint ||
                   decode.state as libc::c_uint ==
                       DECODE_ERROR as libc::c_int as libc::c_uint {
                if decode.state as libc::c_uint ==
                       DECODE_COMPLETE as libc::c_int as libc::c_uint {
                    _sendSTMd = 1 as libc::c_int != 0
                }
                if decode.state as libc::c_uint ==
                       DECODE_ERROR as libc::c_int as libc::c_uint {
                    _sendSTMn = 1 as libc::c_int != 0
                }
                decode.state = DECODE_STOPPED;
                if status.stream_state as libc::c_uint ==
                       STREAMING_HTTP as libc::c_int as libc::c_uint ||
                       status.stream_state as libc::c_uint ==
                           STREAMING_FILE as libc::c_int as libc::c_uint {
                    _stream_disconnect = 1 as libc::c_int != 0
                }
            }
            _decode_state = decode.state;
            pthread_mutex_unlock(&mut decode.mutex);
            pthread_mutex_lock(&mut (*outputbuf).mutex);
            status.output_full = _buf_used(outputbuf);
            status.output_size = (*outputbuf).size as u32_t;
            status.frames_played = output.frames_played_dmp;
            status.current_sample_rate = output.current_sample_rate;
            status.updated = output.updated;
            status.device_frames = output.device_frames;
            if output.track_started {
                _sendSTMs = 1 as libc::c_int != 0;
                output.track_started = 0 as libc::c_int != 0;
                status.stream_start = output.track_start_time
            }
            if _start_output as libc::c_int != 0 &&
                   (output.state as libc::c_int ==
                        OUTPUT_STOPPED as libc::c_int ||
                        output.state as libc::c_int ==
                            OUTPUT_OFF as libc::c_int) {
                output.state = OUTPUT_BUFFER
            }
            if output.state as libc::c_int == OUTPUT_RUNNING as libc::c_int &&
                   !sentSTMu &&
                   status.output_full == 0 as libc::c_int as libc::c_uint &&
                   status.stream_state as libc::c_uint <=
                       DISCONNECT as libc::c_int as libc::c_uint &&
                   _decode_state as libc::c_uint ==
                       DECODE_STOPPED as libc::c_int as libc::c_uint {
                _sendSTMu = 1 as libc::c_int != 0;
                sentSTMu = 1 as libc::c_int != 0;
                if loglevel as libc::c_uint >=
                       lDEBUG as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d output underrun\n\x00" as *const u8 as
                                 *const libc::c_char, logtime(),
                             (*::std::mem::transmute::<&[u8; 14],
                                                       &[libc::c_char; 14]>(b"slimproto_run\x00")).as_ptr(),
                             709 as libc::c_int);
                }
                output.state = OUTPUT_STOPPED;
                output.stop_time = now
            }
            if output.state as libc::c_int == OUTPUT_RUNNING as libc::c_int &&
                   !sentSTMo &&
                   status.output_full == 0 as libc::c_int as libc::c_uint &&
                   status.stream_state as libc::c_uint ==
                       STREAMING_HTTP as libc::c_int as libc::c_uint {
                _sendSTMo = 1 as libc::c_int != 0;
                sentSTMo = 1 as libc::c_int != 0
            }
            if output.state as libc::c_int == OUTPUT_STOPPED as libc::c_int &&
                   output.idle_to != 0 &&
                   now.wrapping_sub(output.stop_time) > output.idle_to {
                output.state = OUTPUT_OFF;
                if loglevel as libc::c_uint >=
                       lDEBUG as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d output timeout\n\x00" as *const u8 as
                                 *const libc::c_char, logtime(),
                             (*::std::mem::transmute::<&[u8; 14],
                                                       &[libc::c_char; 14]>(b"slimproto_run\x00")).as_ptr(),
                             720 as libc::c_int);
                }
            }
            if output.state as libc::c_int == OUTPUT_RUNNING as libc::c_int &&
                   now.wrapping_sub(status.last) >
                       1000 as libc::c_int as libc::c_uint {
                _sendSTMt = 1 as libc::c_int != 0;
                status.last = now
            }
            pthread_mutex_unlock(&mut (*outputbuf).mutex);
            if _stream_disconnect { stream_disconnect(); }
            // send packets once locks released as packet sending can block
            if _sendDSCO { sendDSCO(disconnect_code); }
            if _sendSTMs {
                sendSTAT(b"STMs\x00" as *const u8 as *const libc::c_char,
                         0 as libc::c_int as u32_t);
            }
            if _sendSTMd {
                sendSTAT(b"STMd\x00" as *const u8 as *const libc::c_char,
                         0 as libc::c_int as u32_t);
            }
            if _sendSTMt {
                sendSTAT(b"STMt\x00" as *const u8 as *const libc::c_char,
                         0 as libc::c_int as u32_t);
            }
            if _sendSTMl {
                sendSTAT(b"STMl\x00" as *const u8 as *const libc::c_char,
                         0 as libc::c_int as u32_t);
            }
            if _sendSTMu {
                sendSTAT(b"STMu\x00" as *const u8 as *const libc::c_char,
                         0 as libc::c_int as u32_t);
            }
            if _sendSTMo {
                sendSTAT(b"STMo\x00" as *const u8 as *const libc::c_char,
                         0 as libc::c_int as u32_t);
            }
            if _sendSTMn {
                sendSTAT(b"STMn\x00" as *const u8 as *const libc::c_char,
                         0 as libc::c_int as u32_t);
            }
            if _sendRESP { sendRESP(header.as_mut_ptr(), header_len); }
            if _sendMETA { sendMETA(header.as_mut_ptr(), header_len); }
        }
    };
}
// called from other threads to wake state machine above
#[no_mangle]
pub unsafe extern "C" fn wake_controller() {
    eventfd_write(wake_e, 1 as libc::c_int as eventfd_t);
}
#[no_mangle]
pub unsafe extern "C" fn discover_server(mut default_server:
                                             *mut libc::c_char) -> in_addr_t {
    let mut d: sockaddr_in =
        sockaddr_in{sin_family: 0,
                    sin_port: 0,
                    sin_addr: in_addr{s_addr: 0,},
                    sin_zero: [0; 8],};
    let mut s: sockaddr_in =
        sockaddr_in{sin_family: 0,
                    sin_port: 0,
                    sin_addr: in_addr{s_addr: 0,},
                    sin_zero: [0; 8],};
    let mut buf: *mut libc::c_char = 0 as *mut libc::c_char;
    let mut pollinfo: pollfd = pollfd{fd: 0, events: 0, revents: 0,};
    let mut port: libc::c_uint = 0;
    let mut disc_sock: libc::c_int =
        socket(2 as libc::c_int, SOCK_DGRAM as libc::c_int, 0 as libc::c_int);
    let mut enable: socklen_t = 1 as libc::c_int as socklen_t;
    setsockopt(disc_sock, 1 as libc::c_int, 6 as libc::c_int,
               &mut enable as *mut socklen_t as *const libc::c_void,
               ::std::mem::size_of::<socklen_t>() as libc::c_ulong as
                   socklen_t);
    buf = b"e\x00" as *const u8 as *const libc::c_char as *mut libc::c_char;
    memset(&mut d as *mut sockaddr_in as *mut libc::c_void, 0 as libc::c_int,
           ::std::mem::size_of::<sockaddr_in>() as libc::c_ulong);
    d.sin_family = 2 as libc::c_int as sa_family_t;
    d.sin_port = htons(3483 as libc::c_int as uint16_t);
    d.sin_addr.s_addr = htonl(0xffffffff as libc::c_uint);
    pollinfo.fd = disc_sock;
    pollinfo.events = 0x1 as libc::c_int as libc::c_short;
    loop  {
        if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
            logprint(b"%s %s:%d sending discovery\n\x00" as *const u8 as
                         *const libc::c_char, logtime(),
                     (*::std::mem::transmute::<&[u8; 16],
                                               &[libc::c_char; 16]>(b"discover_server\x00")).as_ptr(),
                     788 as libc::c_int);
        }
        memset(&mut s as *mut sockaddr_in as *mut libc::c_void,
               0 as libc::c_int,
               ::std::mem::size_of::<sockaddr_in>() as libc::c_ulong);
        if sendto(disc_sock, buf as *const libc::c_void,
                  1 as libc::c_int as size_t, 0 as libc::c_int,
                  &mut d as *mut sockaddr_in as *mut sockaddr,
                  ::std::mem::size_of::<sockaddr_in>() as libc::c_ulong as
                      socklen_t) < 0 as libc::c_int as libc::c_long {
            if loglevel as libc::c_uint >=
                   lINFO as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d error sending disovery\n\x00" as *const u8
                             as *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 16],
                                                   &[libc::c_char; 16]>(b"discover_server\x00")).as_ptr(),
                         792 as libc::c_int);
            }
        }
        if poll(&mut pollinfo, 1 as libc::c_int as nfds_t,
                5000 as libc::c_int) == 1 as libc::c_int {
            let mut readbuf: [libc::c_char; 10] = [0; 10];
            let mut slen: socklen_t =
                ::std::mem::size_of::<sockaddr_in>() as libc::c_ulong as
                    socklen_t;
            recvfrom(disc_sock, readbuf.as_mut_ptr() as *mut libc::c_void,
                     10 as libc::c_int as size_t, 0 as libc::c_int,
                     &mut s as *mut sockaddr_in as *mut sockaddr, &mut slen);
            if loglevel as libc::c_uint >=
                   lINFO as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d got response from: %s:%d\n\x00" as
                             *const u8 as *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 16],
                                                   &[libc::c_char; 16]>(b"discover_server\x00")).as_ptr(),
                         799 as libc::c_int, inet_ntoa(s.sin_addr),
                         ntohs(s.sin_port) as libc::c_int);
            }
        }
        if !default_server.is_null() {
            server_addr(default_server, &mut s.sin_addr.s_addr, &mut port);
        }
        if !(s.sin_addr.s_addr == 0 as libc::c_int as libc::c_uint &&
                 running as libc::c_int != 0) {
            break ;
        }
    }
    close(disc_sock);
    return s.sin_addr.s_addr;
}
#[no_mangle]
pub unsafe extern "C" fn slimproto(mut level: log_level,
                                   mut server: *mut libc::c_char,
                                   mut mac: *mut u8_t,
                                   mut name: *const libc::c_char,
                                   mut namefile: *const libc::c_char,
                                   mut modelname: *const libc::c_char,
                                   mut maxSampleRate: libc::c_int) {
    let mut serv_addr: sockaddr_in =
        sockaddr_in{sin_family: 0,
                    sin_port: 0,
                    sin_addr: in_addr{s_addr: 0,},
                    sin_zero: [0; 8],};
    static mut fixed_cap: [libc::c_char; 256] = [0; 256];
    static mut var_cap: [libc::c_char; 128] =
        [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
         0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
         0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
         0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
         0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
         0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
    let mut reconnect: bool = 0 as libc::c_int != 0;
    let mut failed_connect: libc::c_uint = 0 as libc::c_int as libc::c_uint;
    let mut slimproto_port: libc::c_uint = 0 as libc::c_int as libc::c_uint;
    let mut previous_server: in_addr_t = 0 as libc::c_int as in_addr_t;
    let mut i: libc::c_int = 0;
    memset(&mut status as *mut C2RustUnnamed_0 as *mut libc::c_void,
           0 as libc::c_int,
           ::std::mem::size_of::<C2RustUnnamed_0>() as libc::c_ulong);
    wake_e = eventfd(0 as libc::c_int as libc::c_uint, 0 as libc::c_int);
    loglevel = level;
    running = 1 as libc::c_int != 0;
    if !server.is_null() {
        server_addr(server, &mut slimproto_ip, &mut slimproto_port);
    }
    if slimproto_ip == 0 { slimproto_ip = discover_server(server) }
    if slimproto_port == 0 {
        slimproto_port = 3483 as libc::c_int as libc::c_uint
    }
    if !name.is_null() {
        strncpy(player_name.as_mut_ptr(), name,
                64 as libc::c_int as libc::c_ulong);
        player_name[64 as libc::c_int as usize] =
            '\u{0}' as i32 as libc::c_char
    }
    if !namefile.is_null() {
        let mut fp: *mut FILE = 0 as *mut FILE;
        name_file = namefile;
        fp = fopen(namefile, b"r\x00" as *const u8 as *const libc::c_char);
        if !fp.is_null() {
            if fgets(player_name.as_mut_ptr(), 64 as libc::c_int,
                     fp).is_null() {
                player_name[64 as libc::c_int as usize] =
                    '\u{0}' as i32 as libc::c_char
            } else {
                // strip any \n from fgets response
                let mut len: libc::c_int =
                    strlen(player_name.as_mut_ptr()) as libc::c_int;
                if len > 0 as libc::c_int &&
                       player_name[(len - 1 as libc::c_int) as usize] as
                           libc::c_int == '\n' as i32 {
                    player_name[(len - 1 as libc::c_int) as usize] =
                        '\u{0}' as i32 as libc::c_char
                }
                if loglevel as libc::c_uint >=
                       lINFO as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d retrieved name %s from %s\n\x00" as
                                 *const u8 as *const libc::c_char, logtime(),
                             (*::std::mem::transmute::<&[u8; 10],
                                                       &[libc::c_char; 10]>(b"slimproto\x00")).as_ptr(),
                             862 as libc::c_int, player_name.as_mut_ptr(),
                             name_file);
                }
            }
            fclose(fp);
        }
    }
    if !running { return }
    pthread_mutex_lock(&mut (*outputbuf).mutex);
    snprintf(fixed_cap.as_mut_ptr(), 256 as libc::c_int as libc::c_ulong,
             b",ModelName=%s,MaxSampleRate=%u\x00" as *const u8 as
                 *const libc::c_char,
             if !modelname.is_null() {
                 modelname
             } else {
                 b"SqueezeLite\x00" as *const u8 as *const libc::c_char
             },
             if maxSampleRate > 0 as libc::c_int {
                 maxSampleRate as libc::c_uint
             } else { output.supported_rates[0 as libc::c_int as usize] });
    i = 0 as libc::c_int;
    while i < 10 as libc::c_int {
        if !(*codecs.as_mut_ptr().offset(i as isize)).is_null() &&
               (**codecs.as_mut_ptr().offset(i as isize)).id as libc::c_int !=
                   0 &&
               strlen(fixed_cap.as_mut_ptr()) <
                   (256 as libc::c_int - 10 as libc::c_int) as libc::c_ulong {
            strcat(fixed_cap.as_mut_ptr(),
                   b",\x00" as *const u8 as *const libc::c_char);
            strcat(fixed_cap.as_mut_ptr(),
                   (**codecs.as_mut_ptr().offset(i as isize)).types);
        }
        i += 1
    }
    pthread_mutex_unlock(&mut (*outputbuf).mutex);
    memset(&mut serv_addr as *mut sockaddr_in as *mut libc::c_void,
           0 as libc::c_int,
           ::std::mem::size_of::<sockaddr_in>() as libc::c_ulong);
    serv_addr.sin_family = 2 as libc::c_int as sa_family_t;
    serv_addr.sin_addr.s_addr = slimproto_ip;
    serv_addr.sin_port = htons(slimproto_port as uint16_t);
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d connecting to %s:%d\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 10],
                                           &[libc::c_char; 10]>(b"slimproto\x00")).as_ptr(),
                 887 as libc::c_int, inet_ntoa(serv_addr.sin_addr),
                 ntohs(serv_addr.sin_port) as libc::c_int);
    }
    new_server = 0 as libc::c_int as u32_t;
    while running {
        if new_server != 0 {
            previous_server = slimproto_ip;
            serv_addr.sin_addr.s_addr = new_server;
            slimproto_ip = serv_addr.sin_addr.s_addr;
            if loglevel as libc::c_uint >=
                   lINFO as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d switching server to %s:%d\n\x00" as
                             *const u8 as *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 10],
                                                   &[libc::c_char; 10]>(b"slimproto\x00")).as_ptr(),
                         896 as libc::c_int, inet_ntoa(serv_addr.sin_addr),
                         ntohs(serv_addr.sin_port) as libc::c_int);
            }
            new_server = 0 as libc::c_int as u32_t;
            reconnect = 0 as libc::c_int != 0
        }
        sock =
            socket(2 as libc::c_int, SOCK_STREAM as libc::c_int,
                   0 as libc::c_int);
        set_nonblock(sock);
        if connect_timeout(sock,
                           &mut serv_addr as *mut sockaddr_in as
                               *mut sockaddr,
                           ::std::mem::size_of::<sockaddr_in>() as
                               libc::c_ulong as socklen_t, 5 as libc::c_int)
               != 0 as libc::c_int {
            if previous_server != 0 {
                serv_addr.sin_addr.s_addr = previous_server;
                slimproto_ip = serv_addr.sin_addr.s_addr;
                if loglevel as libc::c_uint >=
                       lINFO as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d new server not reachable, reverting to previous server %s:%d\n\x00"
                                 as *const u8 as *const libc::c_char,
                             logtime(),
                             (*::std::mem::transmute::<&[u8; 10],
                                                       &[libc::c_char; 10]>(b"slimproto\x00")).as_ptr(),
                             910 as libc::c_int,
                             inet_ntoa(serv_addr.sin_addr),
                             ntohs(serv_addr.sin_port) as libc::c_int);
                }
            } else {
                if loglevel as libc::c_uint >=
                       lINFO as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d unable to connect to server %u\n\x00"
                                 as *const u8 as *const libc::c_char,
                             logtime(),
                             (*::std::mem::transmute::<&[u8; 10],
                                                       &[libc::c_char; 10]>(b"slimproto\x00")).as_ptr(),
                             912 as libc::c_int, failed_connect);
                }
                sleep(5 as libc::c_int as libc::c_uint);
            }
            // rediscover server if it was not set at startup
            if server.is_null() &&
                   {
                       failed_connect = failed_connect.wrapping_add(1);
                       (failed_connect) > 5 as libc::c_int as libc::c_uint
                   } {
                serv_addr.sin_addr.s_addr =
                    discover_server(0 as *mut libc::c_char);
                slimproto_ip = serv_addr.sin_addr.s_addr
            }
        } else {
            let mut our_addr: sockaddr_in =
                sockaddr_in{sin_family: 0,
                            sin_port: 0,
                            sin_addr: in_addr{s_addr: 0,},
                            sin_zero: [0; 8],};
            let mut len_0: socklen_t = 0;
            if loglevel as libc::c_uint >=
                   lINFO as libc::c_int as libc::c_uint {
                logprint(b"%s %s:%d connected\n\x00" as *const u8 as
                             *const libc::c_char, logtime(),
                         (*::std::mem::transmute::<&[u8; 10],
                                                   &[libc::c_char; 10]>(b"slimproto\x00")).as_ptr(),
                         926 as libc::c_int);
            }
            var_cap[0 as libc::c_int as usize] =
                '\u{0}' as i32 as libc::c_char;
            failed_connect = 0 as libc::c_int as libc::c_uint;
            // check if this is a local player now we are connected & signal to server via 'loc' format
			// this requires LocalPlayer server plugin to enable direct file access
            len_0 =
                ::std::mem::size_of::<sockaddr_in>() as libc::c_ulong as
                    socklen_t;
            getsockname(sock,
                        &mut our_addr as *mut sockaddr_in as *mut sockaddr,
                        &mut len_0);
            if our_addr.sin_addr.s_addr == serv_addr.sin_addr.s_addr {
                if loglevel as libc::c_uint >=
                       lINFO as libc::c_int as libc::c_uint {
                    logprint(b"%s %s:%d local player\n\x00" as *const u8 as
                                 *const libc::c_char, logtime(),
                             (*::std::mem::transmute::<&[u8; 10],
                                                       &[libc::c_char; 10]>(b"slimproto\x00")).as_ptr(),
                             937 as libc::c_int);
                }
                strcat(var_cap.as_mut_ptr(),
                       b",loc\x00" as *const u8 as *const libc::c_char);
            }
            // add on any capablity to be sent to the new server
            if !new_server_cap.is_null() {
                strcat(var_cap.as_mut_ptr(), new_server_cap);
                free(new_server_cap as *mut libc::c_void);
                new_server_cap = 0 as *mut libc::c_char
            }
            sendHELO(reconnect, fixed_cap.as_mut_ptr(), var_cap.as_mut_ptr(),
                     mac);
            slimproto_run();
            if !reconnect { reconnect = 1 as libc::c_int != 0 }
            usleep(100000 as libc::c_int as __useconds_t);
        }
        previous_server = 0 as libc::c_int as in_addr_t;
        close(sock);
    };
}
/* 
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *  
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additions (c) Paul Hermann, 2015-2017 under the same license terms
 *   -Control of Raspberry pi GPIO for amplifier power
 *   -Launch script on power status change from LMS
 */
// make may define: PORTAUDIO, SELFPIPE, RESAMPLE, RESAMPLE_MP, VISEXPORT, GPIO, IR, DSD, LINKALL to influence build
// build detection
// dynamically loaded libraries at run time
// !LINKALL
// config options
// do not reduce as icy-meta max is 4080
/* SUN */
/* SUN */
// printf/scanf formats for u64_t
// logging
// utils.c (non logging)
// buffer.c
// _* called with mutex locked
// slimproto.c
#[no_mangle]
pub unsafe extern "C" fn slimproto_stop() {
    if loglevel as libc::c_uint >= lINFO as libc::c_int as libc::c_uint {
        logprint(b"%s %s:%d slimproto stop\n\x00" as *const u8 as
                     *const libc::c_char, logtime(),
                 (*::std::mem::transmute::<&[u8; 15],
                                           &[libc::c_char; 15]>(b"slimproto_stop\x00")).as_ptr(),
                 966 as libc::c_int);
    }
    running = 0 as libc::c_int != 0;
}
